/*
 * This simulation takes events from simulation pes and lev.  But there 
 * can occur undo operation because strangler mesasage comin. if that hapend
 * simulation must send anti-message to simulation lev. There is loop in graph of simulation 
 * dependens
 */
import cz.zcu.fav.kiv.jsim.*;
import cz.zcu.fav.kiv.jsim.unsecure.*;

public class QueueingNetworksExample_2 {
    public static void main(String[] args) {

        DistributedSimulation   simulation = null;
                
        QueueWithServer       queue1 = null;        
        Server                server1 = null;        
        NetPoint              net_point1 = null;
        
        double                mu1 = 1.0, mu2 = 1.0;
        double                p1 = 0.5, p2 = 0.9;
        
        ClientMainThread      client;
        ClientData            data;        
        
        try
        
        {
            System.out.println("Initializing the simulation..");
            
            simulation = new DistributedSimulation("Queueing Networks Simulation");

            data = new ClientData(simulation);
            
            queue1 = new QueueWithServer("Queue 1", simulation, null);
            
            client = new ClientMainThread(data);
                        
            server1 = new Server("Server 1", simulation, mu1, p1, queue1, null, data, "lev", 0);
            
            net_point1 = new NetPoint("Net Point 1", simulation, queue1, data);
            
            queue1.setServer(server1);
            
            // set simulation name            
            data.setSimulationName("kocka");
            // set receiver simulation name            
            data.setReceiverName("lev");
            
            // set senders simulation name            
            data.addSenderName("pes");
            data.addSenderName("lev");
            // set simulation end time
            net_point1.setSimulationEndTime(1000.0);
            
            // store simulation  componets
            data.addServerAndQueueRef(server1, queue1);
            // set simulation status
            data.setSimulationStatus(1);
            data.setOutputStatus(2);
            client.start();
            
            while (data.comm_ready == false){
                try { /* take a nap */
                    Thread.currentThread().sleep(100);
                }
                catch (InterruptedException E){
                    System.out.println("Get up !!");
                } // end catch
            };
            
            net_point1.activate(0.0);
            
            simulation.message("Activating the generators...");
            
            simulation.message("Running the simulation, please wait.");                        
            
            
            while ((simulation.getCurrentTime() < 1000.0) && (simulation.step() == true)){
            }

            data.putToOutputQueue("last_time");
            data.putToOutputQueue("sim_over");
            
            while(data.order_so_ack == false) {
                data.thread_sleep(200);
            }
            data.putToOutputQueue("cexit");
            
            
   /*
    *  Now, some boring numbers.
    */
            
            simulation.message("Simulation interrupted at time " + simulation.getCurrentTime());
            simulation.message("Queues' statistics:");
            simulation.message("Queue 1: Lw = " + queue1.getLw() + ", Tw = " + queue1.getTw() + ", Tw all = " + queue1.getTwForAllLinks());
            simulation.message("Servers' statistics:");
            simulation.message("Server 1: Counter = " + server1.getCounter() + ", sum of Tq (for transactions thrown away by this server) = " + server1.getTransTq());
            simulation.message("Server 1: Counter Distributed = " + data.output_queue.size());            
            simulation.message("NetPoint 1: Counter = " + (net_point1.inCominCount - 1));
            simulation.message("Number of components in Simulation = " +  data.simData.allSimItem.size());
            simulation.message("Number of undo operation in Simulation = " + simulation.getNumberOfUndo());
            simulation.message("Number of roolback operation in Simulation = " + simulation.getNumberOfRollBack());
                       
            try {
                client.join();
            }
            catch (InterruptedException e){
                System.err.println("Exception: " + e.getMessage());
                System.exit(1);
            }
            
            
            
            data = null;
            
        } // try
        catch (JSimException e) {
            e.printStackTrace();
            e.printComment(System.err);
        }
        
  /*
   *  We must shutdown the simulation.
   */
        finally {
            simulation.shutdown();
        }
    } // main
} // class QueueingNetworksExample

