/*
 *  Deklaration of client's shared object mean stack
 *  Jakub Pastyrik @
 *
 *
 */

import java.io.*;
import java.net.*;
import java.util.*;
import java.util.StringTokenizer;
import cz.zcu.fav.kiv.jsim.*;
import cz.zcu.fav.kiv.jsim.unsecure.*;

/**
 *
 *  List of all simulation
 *
 */

/**
 *
 *  This contain all data to restore simulation to correct  state
 *  thera are informetion for one Server and corresponding queue
 *
 */
class ClientUserItem {
    public  StringBuffer user_name;
    public  double user_lbts;
    
    public ClientUserItem(String ParUserName) {
        user_name = new StringBuffer(ParUserName);
        user_lbts = 0.0;
    }
    
    /**
     *  this method return name of user             <BR>
     *  RV: (String) .. user name                   <BR>
     */
    public String getUserName(){
        return(user_name.toString());
    }
}


class AntiMessageItem {
    public boolean executed;
    public StringBuffer to;
    public double message_1;
    public double message_2;
    
    public AntiMessageItem(double ParAntiMessageStamp, String ParReiceiver){
        executed = false;
        message_1 = ParAntiMessageStamp;
        to = new StringBuffer(ParReiceiver);
    }
}

/*
 *
 *  Packet for one Events
 *
 */
class MessageItem {
    public int flag;
    public boolean executed;
    public StringBuffer from;
    public double message_1;
    public double message_2;
    public StringBuffer to;
    public int gate;
    
    public MessageItem(int ParFlag, String ParFrom, String ParTo, double ParMessage1, double ParMessage2, int ParGate) {
        flag = ParFlag;
        executed = false;
        from = new StringBuffer(ParFrom);
        to = new StringBuffer(ParTo);
        message_1 = ParMessage1;
        message_2 = ParMessage2;
        gate = ParGate;
    }
    
    /**
     *  This method set event in input queue as         <BR>
     *  Executed / not Executed                         <BR>
     *                                                  <BR>
     *  PAR: (boolean)  true .. executed                <BR>
     *                  false .. not executed           <BR>
     *
     */
    public void setEventExecuted(boolean ParExec) {
        this.executed = ParExec;
    }
}

public class ClientData {
    
    public boolean order_cexit;
    public boolean order_sim_over;
    
    public boolean order_stop_all;
    public boolean order_stop_all_ack;
    public boolean order_stop_all_exec;
    
    public boolean order_stop;
    public boolean order_stop_ack;
    public boolean order_stop_exec;
    
    public boolean order_go_all;
    public boolean order_go_all_ack;
    public boolean order_go_all_exec;
    
    public boolean order_go;
    public boolean order_go_ack;
    public boolean order_go_exec;
    
    public boolean order_am_all;
    public boolean order_am_all_ack;
    public boolean order_am_all_exec;
    
    public boolean order_am;
    public boolean order_am_exec;
    public boolean order_am_ack;
    
    public boolean order_lt;
    public boolean order_lt_exec;
    
    public boolean order_so;
    public boolean order_so_exec;
    public boolean order_so_ack;
    
    public boolean order_cexit_exec;
    public boolean order_cexit_ack;
    
    public boolean order_last_event_deadlock;
    
    public boolean pause;
    
    public boolean comm_ready;
    public boolean last_time;
    // public boolean done;
    
    public double am_time_stamp;
    public double am_time_stamp_1;
    
    public StringBuffer simName;
    
    // lock objekt
    private Object    commLock1;
    private Object    commLock2;
    private Object    pauseLock;
    
    public SimulationData simData;
    
    public ArrayList user_list;
    public ArrayList input_queue;
    public ArrayList output_queue;
    public ArrayList ref_field;
    public ArrayList sender_field; // field with names of senders
    public ArrayList anti_message_field;
    
    public JSimSimulation simulation;
    
    private String path;
    
    public FileWriter fwInQ;
    public FileWriter fwOutQ;
    public FileWriter fwTraf;
    public FileWriter fwVis;
    public FileWriter fwSim;
    
    public int outputStatus = 2;
    public int simulationStatus = 2;
    private String serverAddress = "localhost";
    
    //   private static Generator jsim_gen;
    
    /*
     *
     *  Constructor
     *
     */
    
    public ClientData(JSimSimulation  sim) {
        
        path            = new String("c:\\java\\work");
        
        simulation      = sim;
        
        input_queue     = new ArrayList();
        output_queue    = new ArrayList();
        ref_field       = new ArrayList();
        sender_field    = new ArrayList();
        anti_message_field = new ArrayList();
        
        
        commLock1 = new Object();
        commLock2 = new Object();
        pauseLock = new Object();
        
        user_list = new ArrayList();
        
        simData = new SimulationData();
        
        simName = new StringBuffer(10);
        //r_name = new StringBuffer(10);
        
        // flags for simulation over
        order_cexit         = false;
        order_cexit_ack     = false;
        order_cexit_exec    = false;
        
        order_sim_over = false;
        
        // flags for stoping simulation
        order_stop_all      = false;
        order_stop_all_ack  = false;
        order_stop_all_exec = false;
        
        order_stop          = false;
        order_stop_ack      = false;
        order_stop_exec     = false;
        
        // flags for restarting simulation
        order_go_all        = false;
        order_go_all_ack    = false;
        order_go_all_exec   = false;
        
        order_go            = false;
        order_go_ack        = false;
        order_go_exec       = false;
        
        // flags for sending antimessages simulation
        order_am_all        = false;
        order_am_all_ack    = false;
        order_am_all_exec   = false;
        
        order_am            = false;
        order_am_exec       = false;
        order_am_ack        = false;
        
        // flags for simulation over
        order_so            = false;
        order_so_exec       = false;
        order_so_ack        = false;
        
        // flags last_time
        order_lt            = false;
        order_lt_exec       = false;
        
        order_last_event_deadlock = false;
        
        am_time_stamp = 0.0;
        am_time_stamp_1 = 0.0;
        
        pause = false;
        
        comm_ready = false;
        last_time = false;
        // done = false;
        
    } // end constructor
    
    
    /*
     *
     *          M E T H O D S
     *
     */

/**
 *  This method store data needed for situation when undo               <BR>
 *  operation occur                                                     <BR>
 *                                                                      <BR>
 *  Par:    (Server) .. Referencis of simulation component              <BR>
 *          (double) .. Restoring informations                          <BR>
 *
 */    
    
public void addSimUndoItem(Server ParServerRef, double ParCurrentTime, double ParCreationTime, 
double ParTransTg, double ParLinkSumTw, double ParLinkNoOfItemsRemoved, double ParLinkSumLw){
    
    
    // if the simulation is clasified as "depend" you must store restoring dat
    // becuse undo or anti-message can occur
    if (this.simulationStatus == 2) {
    simData.AddTimeItemMain(ParServerRef, ParCurrentTime, ParCreationTime,
                            ParTransTg, ParLinkSumTw, ParLinkNoOfItemsRemoved, ParLinkSumLw);
    }
    
    return;
}
    /**
     *  This method set server ip if this method isnt called            <BR>
     *  server adres is local host                                      <BR>
     *                                                                  <BR>
     *  Par: (String) .. Server IP adress                               <BR>
     *                                                                  <BR>
     */
    
    public void setServerAddress(String ParServerIP){
        this.serverAddress = ParServerIP;
        return;
    }
    
    /**
     *  This method get server ip if this method isnt called            <BR>
     *  server adres is local host                                      <BR>
     *                                                                  <BR>
     *  RV: (String) .. Server IP adress                                <BR>
     *                                                                  <BR>
     */
    
    public String getServerAddress(){
        if (this.serverAddress == null)
            return("localhost");
        else
            return(this.serverAddress);
    }
    
    /**
     *  this method compute LBTS                                        <BR>
     *                                                                  <BR>
     *  RV: (double) .. Lower Bound of Time Stamp                       <BR>
     *
     */
    public double getLBTS(){
        double t_lbts = Double.MAX_VALUE;
        int i;
        ClientUserItem t_item;
        
        for(i = 0; i < this.sender_field.size(); i++) {
            t_item = ((ClientUserItem) this.sender_field.get(i));
            if (t_item.user_lbts < t_lbts) {
                t_lbts = t_item.user_lbts;
            }
        }
        if (sender_field.size() == 0) return(0.0);
        return(t_lbts);
    }
    
    /**
     *  this method add time stamp to user field its nessary duo to     <BR>
     *  computing GTV                                                   <BR>
     *                                                                  <BR>
     *  PAR:    (string)    sender name                                 <BR>
     *          (double)    time stamp                                  <BR>
     */
    public void insertLBTS(String ParSender, double ParTimeStamp){
        int i;
        ClientUserItem t_item;
        for(i = 0; i < this.sender_field.size(); i++){
            t_item = ((ClientUserItem) this.sender_field.get(i));
            if (t_item.user_name.toString().equals(ParSender) == true) {
                t_item.user_lbts = ParTimeStamp;
            }
        }
        return;
    }
    
    
    /**
     *  This method store sender name to field, that is nessary dou to  <BR>
     *  GTV computing                                                   <BR>
     *                                                                  <BR>
     *                                                                  <BR>
     * PAR:                                                             <BR>
     *      (string) .. sender name                                     <BR>
     *
     */
    public void addSenderName(String ParSender){
        this.sender_field.add(new ClientUserItem(ParSender));
        return;
    }
    
    
    /**
     *  Method set simulation status                            <BR>
     *                                                          <BR>
     * PAR: (int) .. 1 this simulation can't by rooled back     <BR>
     *              2 this simulation can by rooled back        <BR>
     *                                                          <BR>
     */
    public void setSimulationStatus(int ParSimStatus) {
        if ((ParSimStatus > 0) && (ParSimStatus < 3))
            this.simulationStatus = ParSimStatus;
        else {
            System.out.println("Inccorect value for set output mode (1,2,3)");
        }
        return;
    }
    
    
    /**
     *  Method set output status                                <BR>
     *                                                          <BR>
     * PAR: (int) .. 1 Output on screen                         <BR>
     *              2 Output on screen + to file                <BR>
     *              3 Output to file                            <BR>
     */
    public void setOutputStatus(int ParOutputStatus) {
        if ((ParOutputStatus > 0) && (ParOutputStatus < 4))
            outputStatus = ParOutputStatus;
        else {
            System.out.println("Inccorect value for set output mode (1,2,3)");
        }
        return;
    }
    
    /**
     *  This methor return index of message from output queue   <BR>
     *  with creation time lower then time stamp of strangler   <BR>
     *  message                                                 <BR>
     *                                                          <BR>
     *  PAR : (double) .. Time when Strangler message comin     <BR>
     *                                                          <BR>
     *  RV : (int) .. Index of item from output Queue           <BR>
     *      else -1 if there no incorect sended messages        <BR>
     */
    
    public int mustGetAntiMessageIndex(double ParTimeStemp) {
        int index = -1;
        int i;
        double lowest = Double.MAX_VALUE;
        MessageItem t_item;
        
        for(i = 0; i < output_queue.size(); i++) {
            t_item = ((MessageItem) output_queue.get(i));
            if (t_item.message_2 > ParTimeStemp) {
                //System.out.println("take  :" + t_item.message_2);
                if (t_item.message_2 < lowest) {
                    index = i;
                    lowest = t_item.message_2;
                }
            }
            
        }
        return(index);
    }
    
    
    /**
     *
     *  Are There any incorect sended messages to other         <BR>
     *  client                                                  <BR>
     *                                                          <BR>
     *  PAR : (double) .. Time when Strangler message comin     <BR>
     *                                                          <BR>
     */
    public int checkOutGoingMessages(double ParTimeStemp) {
        int index = -1;
        int i;
        double lowest = Double.MIN_VALUE;
        MessageItem t_item;
        
        
        index = mustGetAntiMessageIndex(ParTimeStemp);
        if (index == -1) {
            System.out.println("There're no one anti-message to create");
            return(0);
        }
        else {
            t_item = new MessageItem(0, "null", "null", 0.0, 0.0, 0);
            t_item = ((MessageItem) output_queue.get(index));
            
            System.out.println("Must create anti-message with TS:" + t_item.message_1 + " CTS :" + t_item.message_2);
            addAntiMessage(t_item.message_1, t_item.to.toString());
            eraseUndedEvent(t_item.message_1);
            return(1);
        }
    }
    
    /**
     *
     *  erase all events with time stamp greater then time stamp    <BR>
     *  of strangler message as not procesed                        <BR>
     *                                                              <BR>
     *  PAR: (double) .. Time stamp of Stagler m.                   <BR>
     *                                                              <BR>
     *  RV: (int).. number of incorrect procesed events             <BR>
     *              -1  no incorrect event found                    <BR>
     */
    public int eraseUndedEvent(double ParNewSimTime) {
        int i;
        int count = 0;
        int flag = 0;
        int totalNumber = 0;
        
        MessageItem t_item;
        totalNumber = output_queue.size();
        flag = eraseEventOut(ParNewSimTime);
        while(flag == 1) {
            count++;
            flag = eraseEventOut(ParNewSimTime);
        }
        System.out.println("Count of erased Event from output queue : (" + count + " / " + totalNumber + ")");
        if (count == 0) return(-1);
        else return(count);
    }
    
    private int eraseEventOut(double ParNewSimTime) {
        int i;
        int count = 0;
        
        MessageItem t_item;
        
        for(i = 0; i < output_queue.size(); i++){
            t_item = ((MessageItem) output_queue.get(i));
            if (t_item.message_1 >= ParNewSimTime) {
                output_queue.remove(i);
                return(1);
            }
        }
        return(-1);
    }
    /**
     *  This method return time stamp of Event that is queue            <BR>
     *  before antimessage                                              <BR>
     *                                                                  <BR>
     *  PAR: (double) .. Time stamp if anti-message                     <BR>
     *                                                                  <BR>
     *  RV: (double) .. Time stamp of pred message in inputQueue        <BR>
     *
     */
    
    public double getPredEvent(double ParTimeStamp) {
        int i;
        MessageItem t_item;
        int index = -1;
        double higest = Double.MIN_VALUE;
        
        for(i = 0; i < input_queue.size(); i++){
            t_item = ((MessageItem) input_queue.get(i));
            if (t_item.message_1 < ParTimeStamp) {
                if(t_item.message_1 > higest) {
                    index = i;
                    higest = t_item.message_1;
                }
            }
        }
        if (index == -1) return(0.0);
        else {
            t_item = ((MessageItem) input_queue.get(index));
            return(t_item.message_1);
        }
    }
    
    public void addServerAndQueueRef(JSimProcess ParServerRef, JSimHead ParQueueRef){
        simData.AddSimItem(ParServerRef, ParQueueRef);
        return;
    }
    
    
    
    
    /**
     *  This method store anti-message                                  <BR>
     *  to field                                                        <BR>
     *                                                                  <BR>
     *                                                                  <BR>
     * PAR: (double) .. anti-mesage time stamp                          <BR>
     *      (string) .. this AM is for this receiver                    <BR>
     *
     */
    public void addAntiMessage(double ParAntiMessageStamp, String ParReiceiver){
        anti_message_field.add(new AntiMessageItem(ParAntiMessageStamp, ParReiceiver));
        return;
    }
    
    /**
     *  This method get one anti-message                                <BR>
     *  from field                                                      <BR>
     *                                                                  <BR>
     *                                                                  <BR>
     * RV: (AntiMessageItem) .. anti-mesage object                      <BR>
     *      else null if there no more AM in Field                      <BR>
     *
     */
    public AntiMessageItem getAntiMessage(){
        AntiMessageItem t_item;
        int i;
        
        for(i = 0; i < anti_message_field.size(); i++) {
            t_item = ((AntiMessageItem) anti_message_field.get(i));
            if (t_item.executed == false) {
                t_item.executed = true;
                return(t_item);
            }
        }
        return(null);
    }
    
    /**
     *  This method is call when all AM are sended and now are erase    <BR>
     *  from field                                                      <BR>
     *                                                                  <BR>
     * RV: (int) .. number of erased anti messages                      <BR>
     */
    public int eraseAntiMessageField(){
        AntiMessageItem t_item;
        int i, t_length = 0;
        
        t_length = anti_message_field.size();
        // no one AN in field
        if (t_length == 0) return(0);
        
        for(i = 0; i < anti_message_field.size(); i++) {
            anti_message_field.remove((t_length - 1) - i);
        }
        return(t_length);
    }
    
    
    
    /**
     *  This method store referencis of generating item in simulation   <BR>
     *  to field                                                        <BR>
     *                                                                  <BR>
     *                                                                  <BR>
     * PAR: (JSimProcess) .. reference of generator                     <BR>
     *
     */
    
    public void addGeneratorRef(JSimProcess ParGenReferen){
        ref_field.add(new GeneratorRef(ParGenReferen));
        return;
    }
    
    
    private String getPath() {
        
        String  tempFilePath;
        String  tempFileName;
        File    tempFile;
        File    tempDir;
        
        tempFileName    = new String("temp.txt");
        tempFilePath    = new String();        
        tempFile        = new File(tempFileName);
        
        tempFilePath = tempFile.getAbsolutePath();
        tempFilePath = tempFilePath.substring(0, tempFilePath.length() - tempFileName.length());
        
        tempFilePath = tempFilePath + "temp";
        
        tempDir         = new File(tempFilePath);
        
        // dir allready exist
        if (tempDir.exists() == true) {
            System.out.println("Dir allready exists ");
            tempFilePath = tempFilePath + "\\";
        }
        else {// must create dir
            System.out.print("\nCreating dir .. ");
            if (tempDir.mkdir() == true) {
                System.out.println("done\n");
                tempFilePath = tempFilePath + "\\";
            }
            else  {
                System.out.println("failt\n");
                tempFilePath = null;
            }
        }
        return(tempFilePath);
    }
    
    
    /**
     *  Create file for saving of all server trafic     <BR>
     *                                                  <BR>
     *  RV: (int) 1 .. file created succefully          <BR>
     *            -1 ..   can't  created file           <BR>
     */
    public int CreateFile() {
        File fileTraf;
        File fileInQueue;
        File fileOutQueue;
        File fileVizual;
        File fileSimulation;
        
        String tempPath = new String();
        
        if ((tempPath = getPath()) != null) {
            path = tempPath;
        }
        
        fileTraf        = new File(path, simName + "_trafic.txt");
        fileInQueue     = new File(path, simName + "_inqueue.txt");
        fileOutQueue    = new File(path, simName + "_outqueue.txt");
        fileVizual      = new File(path, simName + "_visual.txt");
        fileSimulation  = new File(path, simName + "_simul.txt");
        
        if (fileTraf.exists() == true) {
            fileTraf.delete();
        }
        
        if (fileInQueue.exists() == true) {
            fileInQueue.delete();
        }
        
        if (fileInQueue.exists() == true) {
            fileOutQueue.delete();
        }
        
        if (fileVizual.exists() == true) {
            fileVizual.delete();
        }
        
        if (fileSimulation.exists() == true) {
            fileSimulation.delete();
        }
        
        try {
            System.out.println("Create client report's file");
            
            fileTraf.createNewFile();
            fileInQueue.createNewFile();
            fileOutQueue.createNewFile();
            fileVizual.createNewFile();
            fileSimulation.createNewFile();
            
            fwTraf  = new FileWriter(fileTraf);
            fwInQ   = new FileWriter(fileInQueue);
            fwOutQ  = new FileWriter(fileOutQueue);
            fwVis   = new FileWriter(fileVizual);
            fwSim   = new FileWriter(fileSimulation);
        }
        catch (IOException e){
            System.out.println("Can't create file");
            return(-1);
        }
        return(1);
    }
    
    /**
     *  Close server login file                         <BR>
     *                                                  <BR>
     *  RV: (int) 1 .. file closed succefully           <BR>
     *            -1 ..   can't  close file             <BR>
     */
    public int CloseFile() {
        try {
            fwTraf.close();
            fwInQ.close();
            fwOutQ.close();
            fwVis.close();
            fwSim.close();
        }
        catch (IOException e){
            System.out.println("Can't close file input stream");
            return(-1);
        }
        return(1);
    }
    
    /**
     *  Write-in to visulal login file                   <BR>
     *                                                  <BR>
     * Par: (String) ParLine .. Input text              <BR>
     *                                                  <BR>
     */
    public void WriteToVisFile(String ParLine) {
        try {
            fwVis.write(ParLine+"\n");
            fwVis.flush();
        }
        catch (IOException e){
            //System.out.println("Can't write in");
        }
        return;
    }
    
    /**
     *  Write output to simulation trafic file          <BR>
     *                                                  <BR>
     * Par: (String) ParLine .. Input text              <BR>
     *                                                  <BR>
     */
    public void WriteToSimFile(String ParLine) {
        try {
            if (outputStatus == 1) {
                System.out.println(ParLine);
                System.out.flush();
            }
            if (outputStatus == 2) {
                fwSim.write(ParLine+"\n");
                fwSim.flush();
                System.out.println(ParLine);
                System.out.flush();
            }
            if (outputStatus == 3) {
                fwSim.write(ParLine+"\n");
                fwSim.flush();
            }
            
        }
        catch (IOException e){
            //System.out.println("Can't write in");
        }
        return;
    }
    
    /**
     *  Write-in to client login file                   <BR>
     *                                                  <BR>
     * Par: (String) ParLine .. Input text              <BR>
     *                                                  <BR>
     */
    public void WriteToFile(String ParLine) {
        try {
            fwTraf.write(ParLine+"\n");
        }
        catch (IOException e){
            //System.out.println("Can't write in");
        }
        return;
    }
    
    /**
     *  Write-in to client file  InputQueue             <BR>
     *                                                  <BR>
     */
    public void WriteInQToFile() {
        int i;
        MessageItem t_item;
        
        try {
            fwInQ.write("Client: " + simName +"'s Input Queue\n");
            fwInQ.write("Total count of items in input queue: " + input_queue.size() + " \n");
            fwInQ.write("To  - Time stamp - Creation time - From \n");
            
            for(i = 0; i < input_queue.size(); i++) {
                t_item = ((MessageItem)input_queue.get(i));
                fwInQ.write(t_item.to+ " : " + t_item.message_1 + " : " + t_item.message_2 +" :" + t_item.from + "\n");
            }
            fwInQ.flush();
        }
        catch (IOException e){
            System.out.println("Can't write in");
        }
        return;
    }
    
    /**
     *  Write-in to client file  InputQueue             <BR>
     *                                                  <BR>
     */
    public void WriteOutQToFile() {
        int i;
        MessageItem t_item;
        
        try {
            
            fwOutQ.write("Client:" + simName +"'s Output Queue\n");
            fwOutQ.write("Total count of items in output queue: " + output_queue.size()+" \n");
            fwOutQ.write("To  - Time stamp - Creation time - From \n");
            
            for(i = 0; i < output_queue.size(); i++) {
                t_item = ((MessageItem)output_queue.get(i));
                fwOutQ.write(t_item.to+ " : " + t_item.message_1 + " : " + t_item.message_2 +" :" + t_item.from + "\n");
            }
            fwOutQ.flush();
        }
        catch (IOException e){
            System.out.println("Can't write in");
        }
        return;
    }
    
    private void storeToOutputQueue(int ParFlag, String ParFrom, String ParTo, double ParMessage1, double ParMessage2, int ParGate) {
        output_queue.add(new MessageItem(ParFlag, ParFrom, ParTo, ParMessage1, ParMessage2, ParGate));
    }
    
    /**
     *  get index of item with lowest time stamp and not sended
     */
    public int getIndexOutQ() {
        int i, index = -1;
        double lowest = Double.MAX_VALUE;
        MessageItem t_item;
        
        for(i = 0; i < output_queue.size(); i++) {
            t_item = ((MessageItem) output_queue.get(i));
            if (t_item.executed == false) {
                if (t_item.message_1 < lowest) {
                    lowest = t_item.message_1;
                    index = i;
                }
            }
        }
        return(index);
    }
    
    /**
     *  are in output queue any not sended events in            <BR>
     *                                                          <BR>
     *  RV: (boolean)   true .. yes there are                   <BR>
     *                  false .. no one                         <BR>
     *
     */
    public boolean anyNotSendedEvent(){
        int i;
        
        for(i = 0; i < output_queue.size(); i++) {
            if (((MessageItem) output_queue.get(i)).executed == false) {
                return(true);
            }
        }
        return(false);
    }
    
    /**
     *  This method load one Event item from output Queue       <BR>
     *                                                          <BR>
     *  RV: (MessageItem) .. Event item                         <BR>
     *
     */
    private MessageItem loadFromOutputQueue() {
        int i;
        
        i = getIndexOutQ();
        if (i == -1) return(null);
        else {
            ((MessageItem) output_queue.get(i)).setEventExecuted(true);
            return(((MessageItem) output_queue.get(i)));
        }
    }
    
    /**
     *
     *  Set all events with time stamp greater then time stamp  <BR>
     *  of strangler message as not procesed                    <BR>
     *                                                          <BR>
     *  PAR: (double) .. Time stamp of Stagler m.               <BR>
     *                                                          <BR>
     *  RV: (int).. number of incorrect procesed events         <BR>
     *              -1  no incorrect event found                <BR>
     */
    public int setNotExecuted(double ParNewSimTime) {
        int i;
        int count = 0;
        
        MessageItem t_item;
        
        for(i = 0; i < input_queue.size(); i++){
            t_item = ((MessageItem) input_queue.get(i));
            if (t_item.message_1 > ParNewSimTime) {
                if (t_item.executed == true) count++;
                t_item.setEventExecuted(false);
            }
        }
        
        if (count == 0) return(-1);
        else return(count);
    }
    
    /**
     *  This method delete Events from input queue with time    <BR>
     *  stamp greater then time stamp of strangler message      <BR>
     *  and from simulation whitch can by rolled back           <BR>
     *                                                          <BR>
     *  PAR: (double) .. Strangler Time Stamp                   <BR>
     *                                                          <BR>
     *  RV : (int) .. count erased events
     */
    
    public int deleteRolledEvents(double ParTimeStamp) {
        int i;
        int count = 0;
        int flag = 0;
        int t_length = 0;
        MessageItem t_item;
        
        t_length = this.input_queue.size();
        
        flag = deleteRolledEvent(ParTimeStamp);
        while(flag == 1){
            count++;
            flag = deleteRolledEvent(ParTimeStamp);
        }
        
        System.out.println("Count of deleted Event from input queue : (" + count+ " / " + t_length + ")");
        return(count);
    }
    
    /**
     *  Delete one event from input queue vhen undo comin       <BR>
     *                                                          <BR>
     *  PAR: (double) .. Strangler Time Stamp                   <BR>
     *                                                          <BR>
     *  RV : (int) .. 1 eresed one Event                        <BR>
     *                0 no one Event                            <BR>
     */
    private int deleteRolledEvent(double ParTimeStamp) {
        int i;
        MessageItem t_item;
        int tempSimStatus = 0;
        
        for(i = 0; i < this.input_queue.size(); i++){
            t_item = ((MessageItem) input_queue.get(i));
            if (t_item.message_1 > ParTimeStamp){
                tempSimStatus = t_item.gate / 10;
                if (tempSimStatus == 2) {
                    input_queue.remove(i);
                    return(1);
                }
            }
        }
        return(0);
    }
    /**
     *
     *  erase all events with time stamp greater then time stamp    <BR>
     *  of strangler message as not procesed                        <BR>
     *                                                              <BR>
     *  PAR: (double) .. Time stamp of Stagler m.                   <BR>
     *                                                              <BR>
     *  RV: (int).. number of incorrect procesed events             <BR>
     *              -1  no incorrect event found                    <BR>
     */
    public int eraseRolledEvent(double ParNewSimTime) {
        int i;
        int count = 0;
        int flag = 0;
        int totalCount = 0;
        
        MessageItem t_item;
        totalCount = input_queue.size();
        
        flag = eraseEvent(ParNewSimTime);
        while(flag == 1) {
            count++;
            flag = eraseEvent(ParNewSimTime);
        }
        
        System.out.println("Count of erased incorect processed Events in input queue : (" + count + " / " + totalCount + ")");
        if (count == 0) return(-1);
        else return(count);
    }
    
    private int eraseEvent(double ParNewSimTime) {
        int i;
        int count = 0;
        
        MessageItem t_item;
        
        for(i = 0; i < input_queue.size(); i++){
            t_item = ((MessageItem) input_queue.get(i));
            if (t_item.message_1 > ParNewSimTime) {
                input_queue.remove(i);
                return(1);
            }
        }
        return(-1);
    }
    
    /**
     *
     *  restore all components in simulation to stable state    <BR>
     *                                                          <BR>
     *  PAR: (double) .. Time stamp of Strangler message        <BR>
     *                                                          <BR>
     *  RV: (int) .. Count of restored components item          <BR>
     *
     */
    
    public TimeItem getSimItem(JSimProcess ParProcess) {
        int count = 0;
        int index = -1;
        
        double max_time_stamp = 0.0;
        
        int i, j, t_length;
        
        SimServerItem   t_sim_item = null;
        TimeItem        t_time_item = null, t_time_item_2 = null;
        
        for(i = 0; i < simData.allSimItem.size(); i++) {
            
            t_sim_item = ((SimServerItem) simData.allSimItem.get(i));
            if (t_sim_item.serverRef == ParProcess) {
                //System.out.println("restore field found" + ParProcess.getName());
                t_length = t_sim_item.timeItemState.size();
                //System.out.println("count " + ParProcess.getName() + " : " + t_length);
                for(j = 0; j < t_length; j++){
                    
                    t_time_item = ((TimeItem) t_sim_item.timeItemState.get(j));
                    
                    if (t_time_item.creationTime > max_time_stamp) {
                        
                        max_time_stamp = t_time_item.creationTime;
                        index = j;
                        t_time_item_2 = t_time_item;
                    }
                }
            }
        }
        
        if (index == -1) {
            t_time_item = new TimeItem(0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
            return(t_time_item);
        }
        else {
            return(t_time_item_2);
        }
        
    }
    
    
    /**
     *
     *  erase all incorect processed items from simulation      <BR>
     *                                                          <BR>
     *  PAR: (double) .. Time stamp of Strangler message        <BR>
     *                                                          <BR>
     *  RV: (int) .. Count of removed time item                 <BR>
     *
     */
    
    public int eraseSimItem(double ParNewSimTime) {
        int i, j;
        
        int totalCount = 0;
        int count = 0;
        SimServerItem   t_sim_item;
        TimeItem        t_time_item;
        
        double creationTime = 0.0;
        int t_length = 0;
        
        
        // get time stamp cretion time
        creationTime = getCreationTime(ParNewSimTime);
        
        // count of all components in system
        for(i = 0; i < simData.allSimItem.size(); i++) {
            
            j = 1;
            count = 0;
            
            t_sim_item = ((SimServerItem) simData.allSimItem.get(i));
            t_length = t_sim_item.timeItemState.size();
            while(j == 1) {
                j = eraseItem(t_sim_item, creationTime);
                count++;
            }
            totalCount += count;
            System.out.println(t_sim_item.serverName + ": Count of simulation item eresed : (" + count + " / " + t_length + ")");
        }
        return(totalCount);
    }
    
    /**
     *
     *  erase one incorect processed items from simulation      <BR>
     *                                                          <BR>
     *  PAR: (double) ..  Creation Time stamp of Strangler mess <BR>
     *       (SimServerItem) .. referenc to field of items      <BR>
     *                                                          <BR>
     *  RV: (int) ..  1 Item deleted                            <BR>
     *                -1 There no more item to erase            <BR>
     */
    
    private int eraseItem(SimServerItem ParSimItem, double creationTime){
        
        SimServerItem   t_sim_item;
        TimeItem        t_time_item;
        
        int j, t_length;
        
        t_sim_item = ParSimItem;
        t_length = t_sim_item.timeItemState.size();
        
        for(j = 0; j < t_length; j++){
            
            t_time_item = ((TimeItem) t_sim_item.timeItemState.get(j));
            
            if (t_time_item.creationTime > creationTime) {
                t_sim_item.timeItemState.remove(j);
                return(1);
            }
        }
        return(-1);
    }
    
    /**
     *  Delete all links in queues              <BR>
     *
     */
    public int clearAllLinks() {
        
        SimServerItem t_sim_item;
        int i, count = 0;
        
        // count of all components in system
        for(i = 0; i < simData.allSimItem.size(); i++) {
            t_sim_item = ((SimServerItem) simData.allSimItem.get(i));
            t_sim_item.queueRef.clear();
            count++;
        }
        return(count);
    }
    
    /**
     *
     *  get value of creation Time of Event with TimeStamp  <BR>
     *                                                      <BR>
     *  PAR: (double) .. time stamp of events               <BR>
     *                                                      <BR>
     *  RV: (double) .. Time of creation this event         <BR>
     *                  -1.0 if this event not found        <BR>
     *
     */
    public double getCreationTime(double ParCurentTime) {
        int i, index = -1;
        String s,s1,s2;
        int j = 0, k = 0;
        double t_creationTime = -1.0;
        
        
        s = String.valueOf(ParCurentTime);
        j = s.length() - 2;
        s = s.substring(0, j);
        
        MessageItem t_item;
        synchronized (commLock2) {
            
            for(i = 0; i < input_queue.size(); i++) {
                t_item = ((MessageItem) input_queue.get(i));
                
                s1 = String.valueOf(t_item.message_1);
                k = s1.length() - 2;
                s1 = s1.substring(0, k);
                
                if (s.equals(s1) == true) {
                    index = i;
                    t_creationTime = t_item.message_2;
                }
            }
            
            commLock2.notifyAll();
            
            if (index == -1)  return(-1.0);
            else return(t_creationTime);
            
        }
    }
    
    /**
     *  Store incoming message
     */
    private void storeToInputQueue(int ParFlag, String ParFrom, String ParTo, double ParMessage1, double ParMessage2, int ParGate) {
        input_queue.add(new MessageItem(ParFlag, ParFrom, ParTo, ParMessage1, ParMessage2, ParGate));
    }
    
    /**
     *  get index of item with lowest time stamp and not executed
     */
    public int getIndexInQ() {
        int i, index = -1;
        double lowest = Double.MAX_VALUE;
        MessageItem t_item;
        
        for(i = 0; i < input_queue.size(); i++) {
            t_item = ((MessageItem) input_queue.get(i));
            if (t_item.executed == false) {
                if (t_item.message_1 < lowest) {
                    lowest = t_item.message_1;
                    index = i;
                }
            }
        }
        return(index);
    }
    /**
     *  are in input queue any not executed events in           <BR>
     *  input queue                                             <BR>
     *                                                          <BR>
     *  RV: (boolean)   true .. yes there are                   <BR>
     *                  false .. no one                         <BR>
     *
     */
    public boolean anyNotExecutedEvent(){
        int i;
        
        for(i = 0; i < input_queue.size(); i++) {
            if (((MessageItem) input_queue.get(i)).executed == false) {
                return(true);
            }
        }
        return(false);
    }
    
    /**
     *  This method load one Event item from input Queue        <BR>
     *                                                          <BR>
     *  RV: (MessageItem) .. Event item                         <BR>
     *
     */
    private MessageItem loadFromInputQueue() {
        int i;
        
        i = getIndexInQ();
        if (i == -1) return(null);
        else {
            ((MessageItem) input_queue.get(i)).setEventExecuted(true);
            return(((MessageItem) input_queue.get(i)));
        }
    }
    /**
     *  Set user (simulation) name                      <BR>
     *  Par:    (String)    ParUserName .. user name    <BR>
     */
    
    public void setSimulationName(String ParUserName){
        simName.append(ParUserName);
        this.CreateFile();
        return;
    }
    
    
    /**
     *  Add receiver(simulation) name to field          <BR>
     *  Par:    (String) ParUserName .. user name       <BR>
     */
    
    public void setReceiverName(String ParUserName){
        user_list.add(new ClientUserItem(ParUserName));
        return;
    }
    
    /**
     *  This method return count of user in field       <BR>
     *  RV:    (int)   count of user                    <BR>
     */
    public int getCountOfUser(){
        return(user_list.size());
    }
    
    /**
     *  get user (simulation) name                      <BR>
     *  PAR:    (int)   ParIndex                        <BR>
     *  RV:    (String) ParUserName .. user name        <BR>
     */
    public String getUserName(int ParIndex){
        return((ClientUserItem) user_list.get(ParIndex)).getUserName();
    }
    
    
    
    /**
     *
     *  Store incoming message's to input queue     <BR>
     *                                              <BR>
     *  PAR : (client_message_item) parsed message  <BR>
     *                                              <BR>
     *  RETURN VALUE: (int)                         <BR>
     *      1 .. Stored suceffuly                   <BR>
     *
     */
    public int putToInputQueue(MessageItem par_item){
        int i;
        
        synchronized (commLock2) {
        /*
        while(pause == true){
            try{
                System.out.println("waiting in out_store meyby sim paused");
                System.out.flush();
                wait();
            }
            catch (InterruptedException e) { }
        }
         */
            storeToInputQueue(1, par_item.from.toString(), par_item.to.toString(), par_item.message_1, par_item.message_2, par_item.gate);
            //System.out.println("Stored_InQ("+ input_queue.size() +") :" + par_item.message_1);
            
            commLock2.notifyAll();
            return(1);
            
        }
        
    }
    
    /**
     *
     *  get incoming events from input queue    <BR>
     *                                          <BR>
     *  RV: (MessageItem) event                 <BR>
     */
    public MessageItem getFromInputQueue(){
        int i = 0, j = -1;
        double lowest = Double.MAX_VALUE;
        MessageItem t_item;
        
        synchronized (pauseLock) {
            if (pause == true) {
                try {
                    //System.out.println("waiting in out_load sim pused");
                    System.out.flush();
                    pauseLock.wait();
                }
                catch (InterruptedException e) {
                    System.out.println("Who wake me");
                }
            }
        }
        
        synchronized (commLock2) {
            
            while ((this.anyNotExecutedEvent() == false) && (last_time == false)) {
                try {
                    //System.out.println("waiting in out_load");
                    System.out.flush();
                    commLock2.wait();
                }
                catch (InterruptedException e) {
                    System.out.println("Who wake me");
                }
            }
            
            if (this.order_last_event_deadlock == true) {
                System.out.println("order_last_event_deadlock");
                t_item = new MessageItem(-2,"null","null", 0.0, 0.0, 0);
                return(t_item);
            }
            
            if ((this.anyNotExecutedEvent() == false) && (last_time == true)) {
                //System.out.println("out_load last_time?");
                t_item = new MessageItem(-1,"null","null", 0.0, 0.0, 0);
                return(t_item);
            }
            t_item = loadFromInputQueue();
            //System.out.println("Loaded_InQ("+ input_queue.size() +") :" + t_item.message_1);
            
            commLock2.notifyAll();
            return(t_item);
            
        }
    }// end get
    
    /**
     *  Store incoming orders from simulation       <BR>
     *                                              <BR>
     *  PAR : (String) .. order                     <BR>
     *                                              <BR>
     *  RETURN VALUE:  (int)    1.. known order     <BR>
     *                          -1 .. uknown order  <BR>
     */
    
    public int putToOutputQueue(String par_message){
        
        synchronized (commLock2) {
            
            if (par_message.equals("last_time")) {
                
                order_lt = true;
                unlock();
                
                return(1);
            } // message
            
            if (par_message.equals("sim_over")) {
                
                WriteInQToFile();
                WriteOutQToFile();
                CloseFile();
                
                order_so = true;
                unlock();
                
                return(1);
            } // message
            
            
            if (par_message.equals("cexit")) {
                
                order_cexit = true;
                unlock();
                
                return(1);
            } // message
            
            return(-1);
            
        }
    }
    
    public void undo(){
        int i = 0;
        int k = 0;
        char[] progress_bar = {'|','/','-','\\'};
        
        synchronized (commLock2) {
            
            order_stop_all = true;
            pause = true;
            
            //System.out.println("-------- U N D O -----------------");
            unlock();
            return;
        }
    }
    
    public void thread_sleep(int par_time_to_sleep) {
        try {
            Thread.sleep(par_time_to_sleep);
        }
        catch (InterruptedException e){
            System.err.println("Exception: " + e.getMessage());
        }
        return;
    }
    
    
    
    /**
     *
     *  put incoming Event from simulation to output queue      <BR>
     *                                                          <BR>
     *  PAR :                                                   <BR>
     *      (double) .. time stamp of event                     <BR>
     *      (double) .. time of creation of event               <BR>
     *      (String) .. name of receiver of event               <BR>
     *      (int) .. number of gate in simulation               <BR>
     *                                                          <BR>
     *  RETURN VALUE:  (int)                                    <BR>
     *      1 .. Stored suceffuly                               <BR>
     *
     */
    
    public int putToOutputQueue(double par_message_1, double par_message_2, String ParRecvName, int ParGate){
        int i;
        int tempGate;
        synchronized (commLock1) {
            
            while(pause == true){
                try{
                    //System.out.println("waiting in in_store meyby sim paused");
                    //System.out.flush();
                    commLock1.wait();
                }
                catch (InterruptedException e) { }
            }
            // lower dec number is gate number
            // higer dec number is status of simulation
            tempGate = this.simulationStatus * 10 + ParGate;
            storeToOutputQueue(1, simName.toString(), ParRecvName, par_message_1, par_message_2, tempGate);
            //System.out.println("Stored_outQ("+ output_queue.size() +") :" + par_message_1);
            
            commLock1.notifyAll();
            
            return(1);
            
        }
    }// end in_store
    
    
    /**
     *
     *  take event from output queue with lowest time   <BR>
     *                                                  <BR>
     *  RV: (MessageItem)                               <BR>
     *      item with event                             <BR>
     *                                                  <BR>
     */
    public MessageItem getFromOutputQueue(){
        int i = 0, j = -1;
        double lowest = Double.MAX_VALUE;
        MessageItem t_item;
        
        synchronized (commLock1) {
            
            //System.out.println(pause + "pause IL");
            while ((this.anyNotSendedEvent() == false) && (order_lt == false)
            && (order_so == false) && (order_cexit == false) && (pause == false)){
                try {
              //      System.out.println("waiting in getFromOutputQueue");
               //     System.out.flush();
                    commLock1.wait();
                }
                catch (InterruptedException e) { }
            }
            
            if (pause == true) {
                //System.out.println("getFromOutputQueue pause");
                t_item = new MessageItem(-2,"null","null",0.0,0.0, 0);
                return(t_item);
            }
            
            if ((this.anyNotSendedEvent() == false) && (order_lt == true)) {
                //System.out.println("getFromOutputQueue last_time");
                t_item = new MessageItem(-2,"null","null",0.0,0.0, 0);
                return(t_item);
            }
            
            if ((this.anyNotSendedEvent() == false) && (order_so == true)) {
                //System.out.println("getFromOutputQueue sim_over");
                t_item = new MessageItem(-2,"null","null",0.0,0.0, 0);
                return(t_item);
            }
            if (order_cexit == true) {
                t_item = new MessageItem(-2,"null","null",0.0,0.0, 0);
                //System.out.print("*");
                return(t_item);
            }
            
            t_item = loadFromOutputQueue();
            // System.out.println("Loaded_OutQ("+ output_queue.size() +") :" + t_item.message_1);
            
            commLock1.notifyAll();
            return(t_item);
            
        }
    }// end get
    
    /**
     *
     *  Free locked simulation thread   <BR>
     *
     */
    public void unlock() {
        synchronized (commLock1) {
            commLock1.notifyAll();
        }
        synchronized (commLock2) {
            commLock2.notifyAll();
        }
        return;
    }
    
    
    public void unLockPause() {
        synchronized (pauseLock) {
            pauseLock.notifyAll();
        }
        return;
    }
    
    protected void finalize() throws Throwable {
        int i;
        /*
        for (i = 0; i < IN_LEVEL; i++)
            in_stack[i] = null;
        for (i = 0; i < OUT_LEVEL; i++)
            out_stack[i] = null;
         */
        
        /*
        for (i = 0; i < count_user(); i++)
            user_list.remove(i);
         */
        System.out.println("Finalizing");
        user_list = null;
        System.gc();
        super.finalize();
    } // end finalize
    
    
    
}// end class buffer_stack