import java.io.*;
import java.net.*;


public class ClientMainThread extends Thread{
    public final int DEFAULT_PORT = 6789;
    private ClientData t_client_data;
    
    
    public ClientMainThread(ClientData ParClientData) {
        t_client_data = ParClientData;
    }
    
    public void run() {
        
        int port = DEFAULT_PORT;
	//t_client_data = new client_data(null);
        String address = "";
        Socket s = null;

                                
        try {
            PrintWriter writer;
            BufferedReader reader;

            address = t_client_data.getServerAddress();
            s = new Socket(address, port); 
            
            // create streams for reading and writing            
            reader = new BufferedReader(new InputStreamReader(s.getInputStream()));

            writer = new PrintWriter(new OutputStreamWriter(s.getOutputStream()));
            
            System.out.println("Connected to " + s.getInetAddress() +":" + s.getPort());
            
            String line; // read the first response (a line) from the server
            
            line = reader.readLine(); // write the line to console
            System.out.println(line);
            
            ClientWriteThread v_3 = new ClientWriteThread(writer, t_client_data); 
            v_3.start();
            ClientReadThread v_4 = new ClientReadThread(reader, t_client_data); // vytvori vlakno
            v_4.start();
            
            try {
                v_3.join();
                v_4.join();
                
            }catch (InterruptedException e){
                System.err.println("Exception: " + e.getMessage());
                System.exit(1);
            }
            
            //if (v_4.isAlive() == true) v_4.interrupt();
            reader.close();
            writer.close();
        }
        catch (IOException e) {
            System.err.println(e);
            System.out.println("Server isn't ready");
        }
        // always be sure to close the socket
        finally {
            try {
                if (s != null) s.close();
                System.out.println("Closing the client"); // server.close ();
                System.exit(0);
            }
            catch (IOException e2) { }
        }
    }
}