import java.io.*;
import java.net.*;
import java.util.StringTokenizer;
import cz.zcu.fav.kiv.jsim.*;

/*
 * client_read_thread.java
 *
 * Created on 20. bezen 2004, 17:03
 */

/**
 *
 * @author  Kuba
 */


public class ClientReadThread extends Thread {
    
    private String line;
    private BufferedReader readerStream;
    private ClientData data;
    private MessageItem message;
    
    public ClientReadThread(BufferedReader ParReader, ClientData ParClientData) {
        
        super("client_read_thread");
        
        readerStream    = ParReader;
        data            = ParClientData;
        message         = new MessageItem(1,"null","null",0.0,0.0, 0);
    }
    
    public void run() {
        
        for(;;) {
            
            try {
                line = readerStream.readLine();// read a line from the server
                message = this.getMessageItem(line, message);
            }
            catch (IOException e1) {
                System.err.println("Exception: " + e1.getMessage());
                break;
            } //end catch
                       
            if (line == null) {
                System.out.println("Connection closed by server.");
                break;
            }// ned if
            
            // Message
            if (message.flag == 1){
                
                data.WriteToFile("Message <-  " + line);                
                //System.out.println("Message <- " + line);
                System.out.flush();
                
               // Thread.yield();
            }
            
            // connection broken
            if (message.flag == -1) {
                
                data.WriteToFile("Connection closed by server.");                
               // System.out.println("Connection closed by server.");
               // System.out.flush();
                
                break;
            }
            
            // cexit
            if (message.flag == -3){
                
               // System.out.println("Client closing input");
                data.WriteToFile("Client closing input");                
                System.out.flush();
                
                break;
            }
            
            // order STOP
            if (message.flag == -4){
                
                data.order_stop = true;
                data.pause = true;
                
                data.WriteToFile("Client recv STOP");
                data.unlock();
            }
            
            // comm ready
            if (message.flag == -5){
                data.comm_ready = true;
                
                data.WriteToFile("Client recv READY");
            }
            
            // comm not ready
            if (message.flag == -6){
                data.WriteToFile("Client recv NOT_READY");
                Thread.yield();
            }
            
            // order GO
            if (message.flag == -7){
                
                data.order_go = true;
                
                data.WriteToFile("Client recv GO");
                
                data.unlock();
            }
            
            
            // Last_time_commin
            if (message.flag == -8){

                data.last_time = true;
                
                data.WriteToFile("Client recv LAST_TIME");

                data.unlock();
            }
            
            // order STOP_ALL_ACK
            if (message.flag == -9){
                
                data.order_stop_all_ack = true;
                data.order_go_all_exec = false;
                
                data.WriteToFile("Client recv STOP_ALL_ACK");
                
                data.unlock();
            }
            
            // order GO_ALL_ACK
            if (message.flag == -10){
                
                data.order_stop_all = false;
                data.order_stop_all_ack = false;
                data.order_go_all_ack = true;
                data.pause = false;
                
                data.WriteToFile("Client recv GO_ALL_ACK");
                
                data.unlock();
            }
            
            // order AM_ALL_ACK
            if (message.flag == -11){
                
                data.order_am_all_ack = true;
                
                data.WriteToFile("Client recv AM_ALL_ACK");
                
                data.unlock();
            }
            
            //  AntiMessage
            if (message.flag == -12){

                data.order_am = true;
                data.am_time_stamp_1 = message.message_1;
                
                data.WriteToFile("AntiMessage <- " + line);
                
                ((DistributedSimulation) data.simulation).operationRollback(message.message_1, data);
                
                data.unlock();
            }
            
            // order SIM_OVER_ACK
            if (message.flag == -13){
                
                data.order_so_ack = true;

                data.WriteToFile("Client recv SIM_OVER_ACK");
                
                data.unlock();
            }
            
            // Last_event_deadlock
            if (message.flag == -14){

                data.last_time = true;
                data.order_last_event_deadlock = true;
                
                data.WriteToFile("Client recv LAST_EVENT_DEADLOCK");

                data.unlock();
            }
            
            
            if (message.flag == -20){
                System.out.println("Erno ??");
                System.out.flush();
            }
            
            
        }// end for()
    }//end run
    
    public MessageItem getMessageItem(String ParLine, MessageItem ParTempItem){
        int i = 0, crc = 0;
        String[] token;
        token = new String[10];
        
        /* com-line broken */
        if (ParLine == null) {
            ParTempItem.flag = -1;
            return(ParTempItem);
        }
        
        /* getMessageItem */
        StringTokenizer st = new StringTokenizer(ParLine,":");
        
        while(st.hasMoreTokens()) {
            token[i] = new String(st.nextToken());
            i++;
        }
        
        try {
            crc = Integer.valueOf(token[0]).intValue();
        }
        catch (NumberFormatException e) {
            System.out.println(ParLine);
            System.out.println("Can't convert variable");
            ParTempItem.flag = -20;
            return(ParTempItem);
        }
        
        
        ParTempItem.flag = -20;
        
        // message
        if (crc == 1) {
            
            ParTempItem.flag = 1;
            ParTempItem.from.delete(0, ParTempItem.from.length());
            ParTempItem.from.append(token[1]);
            
            try {
                ParTempItem.message_1 = Double.valueOf(token[2]).doubleValue();
                ParTempItem.message_2 = Double.valueOf(token[3]).doubleValue();
                ParTempItem.gate = Integer.valueOf(token[5]).intValue();
            }
            catch (NumberFormatException e) {
                System.out.println("Can't pars variable");
                ParTempItem.flag = -20;
                return(ParTempItem);
            }
            
            ParTempItem.to.delete(0, ParTempItem.to.length());
            ParTempItem.to.append(token[4]);
            
            if (data.putToInputQueue(ParTempItem) == -1)
                System.out.println("Can't store incoming message");
        }
        
        // orders
        if (crc == 2) {
            if (token[2].equals("cexit")) ParTempItem.flag = -3;
            if (token[2].equals("stop")) ParTempItem.flag = -4;
            if (token[2].equals("ready")) ParTempItem.flag = -5;
            if (token[2].equals("not_ready")) ParTempItem.flag = -6;
            if (token[2].equals("go")) ParTempItem.flag = -7;
            if (token[2].equals("last_time")) ParTempItem.flag = -8;
            if (token[2].equals("stop_all_ack")) ParTempItem.flag = -9;
            if (token[2].equals("go_all_ack")) ParTempItem.flag = -10;
            if (token[2].equals("am_all_ack")) ParTempItem.flag = -11;
            if (token[2].equals("sim_over_ack")) ParTempItem.flag = -13;           
            if (token[2].equals("last_event_deadlock")) ParTempItem.flag = -14;
            if (token[2].equals("erno")) ParTempItem.flag = -20;
        }
        
        // anti mesage
        if (crc == 3) {
            if (token[2].equals("anti_message")) {
                ParTempItem.flag = -12;
                try {
                    ParTempItem.message_1 = Double.valueOf(token[3]).doubleValue();
                }
                catch (NumberFormatException e) {
                    System.out.println("Can't pars variable");
                    ParTempItem.flag = -20;
                    return(ParTempItem);
                }
            }
        }
        
        token = null;
        System.gc();
        
        return(ParTempItem);
        
    }// end check */
    
}// end class

