import java.io.*;
import java.net.*;


public class ClientWriteThread extends Thread {
    
    private PrintWriter     writerStream;
    private ClientData      data;
    private MessageItem     t_item_1;
    private AntiMessageItem t_item_2;         // temporary item for anti-message
    private StringBuffer    message;
    
    public ClientWriteThread(PrintWriter ParWriter,  ClientData ParClientData) {
        super("client_write_thread");
        
        writerStream    = ParWriter;
        data            = ParClientData;
        message         = new StringBuffer(160);
        t_item_1        = new MessageItem(1,"null","null", 0.0, 0.0, 0);
    }
    
    public void run() {
        int k = 0;
        char[] progress_bar = {'|','/','-','\\'};
        
        // order com_ready sended
        boolean cr_exec = false;
        
        //  order go sended
        boolean og_exec = false;
        
        //  order stop sended
        boolean os_exec = false;

        for (;;) {
            
            /*  COM_READY
             *  Comunnication not ready we aren't connected we must send
             *  login message and wait for answer
             */
            if (data.comm_ready == false) {
                /* login message */
                if (cr_exec == false) {
                    
                    message = getNewMessage(message, null, null, 2);
                    writerStream.println(message.toString()); // send it to the server
                    writerStream.flush();
                    
                    data.WriteToFile("Client send READY");
                    
                    cr_exec = true;
                } /* waiting for answer */
                else {
                    k = (k + 1) % 4;
                    System.out.print("\b" + progress_bar[k]);
                    thread_sleep(200);
                }
            }
            
            /*  GO_ACK
             *  client is conected succesfully but order go comin
             *  you must sand go_Ack
             *  simulation is paused
             */
            if ((data.comm_ready == true) && (data.order_go == true)){
                if (data.order_go_exec == false) {
                    message = this.getNewMessage(message, t_item_1, null, 6);
                    
                    writerStream.println(message.toString()); // send it to the server
                    writerStream.flush();
                    
                    data.WriteToFile("Client send GO_ACK");                    
                    
                    data.order_go = false;
                    data.order_stop = false;
                    data.order_stop_exec = false;
                    data.pause = false;
                    
                    data.unlock();
                    data.unLockPause();
                    
                    data.order_go_exec = true;
                }
                else {
                    //System.out.println(data.last_time + " : " + data.order_cexit);
                }
            }
            
            
            
            /*  STOP_ACK
             *  client is conected succesfully but order stop comin
             *  you must sand stop_Ack
             *  simulation is paused
             */
            if ((data.comm_ready == true) && (data.order_stop == true)){
                if (data.order_stop_exec == false) {
                    
                    message = getNewMessage(message, t_item_1, null, 5);
                    
                    writerStream.println(message.toString());
                    writerStream.flush();
                    
                    data.WriteToFile("Client send STOP_ACK");
                    
                    data.order_stop_exec = true;
                    data.order_go_exec = false;
                }
                else {
                    //System.out.println(data.last_time + " : " + data.order_cexit);
                }
            }
            
            /*  MESSAGE
             *  client is conected succesfully and can start simulation a
             *  message exchanging
             *
             */
            
            if ((data.comm_ready == true) && (data.pause == false)
            && (data.order_so_exec == false)) {
                
                os_exec = false;
                og_exec = false;
                
                t_item_1 = data.getFromOutputQueue();
                
                if (t_item_1.flag == 1) {
                    
                    message = this.getNewMessage(message, t_item_1, null, 1);
                    writerStream.println(message.toString()); // send it to the server
                    writerStream.flush();
                    
                    data.WriteToFile("Message ->  " + message.toString());
                }
                else {
                    //System.out.println(data.last_time + " : " + data.order_cexit);
                }
            }
            
            /*  STOP_ALL
             *  client is conected succesfully but undo comin
             *  you must sand stop_all
             *  simulation is paused
             */
            
            if ((data.comm_ready == true) && (data.order_stop_all == true)){
                if (data.order_stop_all_exec == false) {
                    
                    data.pause = true;
                    data.order_stop_all_exec = true;
                    
                    message = this.getNewMessage(message, t_item_1, null, 7);
                    writerStream.println(message.toString()); // send it to the server
                    writerStream.flush();
                    
                    data.WriteToFile("Client send STOP_ALL");
                    
                }
                else {
                    k = (k + 1) % 4;
                    //System.out.println("4");
                    System.out.print("\b" + progress_bar[k]);
                    //System.out.print("+");
                    data.thread_sleep(25);
                }
            }
            
            /*  ANTI_MESSAGE_ACK
             *  client must Ack_am
             *  if are generate any new AM they must by send before ACK
             *  simulation is paused
             */
            if ((data.comm_ready == true) && (data.order_am == true)){
                
                //if (data.simName.toString().equals("lev") == true) {
                
                
                // get first anti-message
                t_item_2 = data.getAntiMessage();
                while (t_item_2 != null) {
                    
                    message = this.getNewMessage(message, null, t_item_2, 9);
                    writerStream.println(message.toString()); // send it to the server
                    writerStream.flush();
                    
                    data.WriteToFile("AntiMessage -> " + message.toString());                                        
                    //data.WriteToSimFile("AntiMessage :" + t_item_2.message_1 + ":" + t_item_2.to);                    
//                    System.out.println("AntiMessage -> " + message.toString());
                    System.out.flush();
                    
                    // get next anti-message
                    t_item_2 = data.getAntiMessage();
                }
                
                data.eraseAntiMessageField();
                
                message = getNewMessage(message, null, null, 10);
                writerStream.println(message.toString()); // send it to the server
                writerStream.flush();
                
                data.WriteToFile("Client send AM_ACK");
//                System.out.println("Client send AM_ACK");
//                System.out.flush();
                
                data.order_am = false;
            }
            
            /**
             *  ANTI MESSAGE
             *  Primar roolback
             */
            if ((data.comm_ready == true) && (data.order_stop_all_ack == true)
            && (data.order_am_all == true)) {
                if (data.order_am_all_exec == false) {
                    
                    // get first anti-message
                    t_item_2 = data.getAntiMessage();
                    while (t_item_2 != null) {
                        
                        message = this.getNewMessage(message, null, t_item_2, 9);
                        writerStream.println(message.toString()); // send it to the server
                        writerStream.flush();
                        
                        data.WriteToFile("AntiMessage -> " + message.toString());
                        data.WriteToSimFile("AntiMessage :" + t_item_2.message_1 + ":" + t_item_2.to);                    
//                        System.out.println("AntiMessage -> " + message.toString());
//                        System.out.flush();
                        
                        // get next anti-message
                        t_item_2 = data.getAntiMessage();
                    }
                    
                    data.eraseAntiMessageField();
                    data.order_am_all_exec = true;
                }
                else {
                    //System.out.print("x");
//                    System.out.println("3");
                    data.thread_sleep(50);
                }
            }
            
            /*  GO_ALL
             *  client is conected succesfully but undo comin
             *  you must sand stop_all
             *  simulation is paused
             */
            
            if ((data.comm_ready == true) && (data.order_stop_all_ack == true)
            && (data.order_go_all == true)){
                
                if (data.order_go_all_exec == false) {
                    
                    message = getNewMessage(message, t_item_1, null, 8);
                    writerStream.println(message.toString()); // send it to the server
                    writerStream.flush();
                    
                    data.WriteToFile("Client send GO_ALL");
//                    System.out.println("Client send GO_ALL");
//                    System.out.flush();
                    
                    data.order_go_all_exec = true;
                }
                else {
                    //k = (k + 1) % 4;
                    //System.out.print("\b" + progress_bar[k]);
//                    System.out.println("2");
                    data.thread_sleep(50);
                }
            }
            
            /*  Last_Time
             *  if simulation buffer is empty, all messages sended and
             *  order simulation executed but not send yet
             */
            
            if ((data.order_lt == true) && (data.anyNotSendedEvent() == false)
            && (data.order_lt_exec == false)){
                
                for (int i = 0; i < data.getCountOfUser(); i++) {
                    message = getNewMessage(message, null, null, 3);
                    writerStream.println(message.toString()); // send it to the server
                    writerStream.flush();             
                }
                
                data.WriteToFile("Client send LAST_TIME");
//                System.out.println("Client send LAST_TIME");
//                System.out.flush();
                
                data.order_lt_exec = true;
            }
            
            /*  Sim_over
             *  if simulation buffer is empty, all messages sended and
             *  order simulation executed but not send yet
             */
            
            if ((data.order_so == true) && (data.anyNotSendedEvent() == false)
            && (data.order_so_exec == false)){
                
                message = getNewMessage(message, null, null, 11);
                writerStream.println(message.toString()); // send it to the server
                writerStream.flush();
                
                data.WriteToFile("Client send SIM_OVER");
//                System.out.println("Client send SIM_OVER");
//                System.out.flush();
                
                data.order_so_exec = true;
            }
            
            if (data.order_so_exec == true) {
                k = (k + 1) % 4;
                System.out.print("\b" + progress_bar[k]);
                //System.out.println("5");
                thread_sleep(350);
            }
            
            /* CEXIT
             *  if simulation is over, simulation over command sended
             *  a we want close client (order cexit executed)
             *  only for client who are sending mesages to other's
             */
            
            if ((data.order_so_ack == true) && (data.order_cexit == true)){
                
                message = this.getNewMessage(message, null, null, 4);
                writerStream.println(message.toString()); // send it to the server
                writerStream.flush();
                
                data.WriteToFile("Client closing output");
//                System.out.println("Client closing output");
//                System.out.flush();
                break;
            }
            
        } //end for
    } // end run
    
    
    /**
     *
     *  Creating message
     *
     *  PAR:    ParItem_1 (ClientMessageItem)    ..  contain time stamp's
     *          ParMessageType (Int)  .. type of message
     *          1   ..  time stamps message
     *          2   ..  order comm_ready
     *          3   ..  simulation over
     *          4   ..  order cexit
     *  RV:     (StringBuffer) assambled message
     */
    
    public StringBuffer getNewMessage(StringBuffer ParBuffer, MessageItem ParItem_1, AntiMessageItem ParItem_2, int ParMessageType) {
        int message_type = 1;
        int i;
        int lastTimeIndex = 0;
        
        ParBuffer.delete(0, ParBuffer.length()); // clear buffer
        
        // message
        if (ParMessageType == 1) {
            ParBuffer.append("1:" + data.simName + ':' + ParItem_1.message_1 + ':'  + ParItem_1.message_2 + ':' + ParItem_1.to.toString() + ':' + ParItem_1.gate + ':' + data.getLBTS());
            return(ParBuffer);
        }
        
        // comm ready
        if (ParMessageType == 2) {
            ParBuffer.append("2:" + data.simName + ":comm_ready");
            for (i = 0; i < data.getCountOfUser(); i++) {
                ParBuffer.append(':' + data.getUserName(i));
            }
            return(ParBuffer);
        }
        
        // last_time
        if (ParMessageType == 3) {
            ParBuffer.append("2:" + data.simName + ":last_time:" + data.getUserName(lastTimeIndex));
            lastTimeIndex++;
            return(ParBuffer);
        }
        
        //cexit
        if (ParMessageType == 4) {
            ParBuffer.append("2:" + data.simName + ":cexit:server");
            return(ParBuffer);
        }
        
        // stop_ack
        if (ParMessageType == 5) {
            ParBuffer.append("2:" + data.simName + ":stop_ack:server");
            return(ParBuffer);
        }
        
        // go_ack
        if (ParMessageType == 6) {
            ParBuffer.append("2:" + data.simName + ":go_ack:server");
            return(ParBuffer);
        }
        
        // go_ack
        if (ParMessageType == 7) {
            ParBuffer.append("2:" + data.simName + ":stop_all:server");
            return(ParBuffer);
        }
        
        // go_all
        if (ParMessageType == 8) {
            ParBuffer.append("2:" + data.simName + ":go_all:server");
            return(ParBuffer);
        }
        
        // Anti - mesage
        if (ParMessageType == 9) {
            ParBuffer.append("3:" + data.simName + ":anti_message:"+ ParItem_2.message_1 + ":" + ParItem_2.to);
            return(ParBuffer);
        }
        
        // Anti - mesage - ACK
        if (ParMessageType == 10) {
            ParBuffer.append("3:" + data.simName + ":anti_message_ack:"+ data.am_time_stamp_1 + ":server");
            return(ParBuffer);
        }
        
        // Sim_over
        if (ParMessageType == 11) {
            ParBuffer.append("2:" + data.simName + ":sim_over:server");
            return(ParBuffer);
        }
        
        // temp = null;
        System.gc();
        
        return(ParBuffer);
        
    }// end getNewMessage
    
    /**
     *
     *  Make thread sleep for while         <BR>
     *                                      <BR>
     *  Par: (int) .. sleep for time        <BR>
     *
     */
    
    private void thread_sleep(int par_time_to_sleep) {
        try {
            Thread.sleep(par_time_to_sleep);
        }
        catch (InterruptedException e){
            System.err.println("Exception: " + e.getMessage());
        }
        return;
    }
    
    
}// end class
