/*
 *  A simple generator. Creates new transactions and puts them into a queue.
 *  Look into the documentation for additional information.
 *
 */

import cz.zcu.fav.kiv.jsim.*;

public class Generator extends JSimProcess {
    private double                 lambda;
    private QueueWithServer        queue;
    private DistributedSimulation            simulation;
    private ClientData            data;
    
    public Generator(String name, DistributedSimulation sim, double l, QueueWithServer q, ClientData ParData) throws JSimSimulationAlreadyTerminatedException, JSimInvalidParametersException, JSimTooManyProcessesException {
        super(name, sim);
        lambda = l;
        queue = q;
        simulation = sim;
        data = ParData;
    } // constructor
    
    protected void life() {
        JSimLink      link;
        
        try {
            while (true) {
                
    /*
     *  Periodically creating new transactions and putting them into the queue.
     */         
                data.WriteToSimFile(getName() + ": CT :" + myParent.getCurrentTime());
                //message(getName() + ": CT :" + myParent.getCurrentTime());
                link = new JSimLink(new Transaction(myParent.getCurrentTime()));
                link.into(queue);
                if (queue.getServer().isIdle()) {
                    //message(getProcessName() + ": The server is idle, waking it up...");
                    queue.getServer().activate(myParent.getCurrentTime());
                }
                
                try{
                    hold(JSimSystem.negExp(lambda));
                }
                catch (JSimSecurityException e) {
                    message(getName() + ": Can't HOLD exception :" + myParent.getCurrentTime());
                }
                
            } // while
        } // try
        catch (JSimException e) {
            e.printStackTrace();
            e.printComment(System.err);
        }
    } // life
} // class Generator

