import java.net.*;
import java.io.*;

class ServerThread extends Thread {
    //public final static int DEFAULT_PORT = 6789;
    private Socket t_client = null;
    private int t_id;
    private ServerData t_comm_data;
    private ServerGui t_gui;
    
    
    public ServerThread(Socket par_socket, int par_id, ServerData par_comm_data, ServerGui par_gui) {
        
        super("Server Thread");
        t_client = par_socket;
        t_id = par_id;
        t_comm_data = par_comm_data;
        t_gui = par_gui;
    }
    
    public void run() {
        
        Socket cSock = t_client;
        
        PrintWriter writer;
        BufferedReader reader;
        
        try {
            String line;
            System.out.println("Accepted from " + cSock.getInetAddress());
            t_comm_data.base[t_id].clientAdrress = cSock.getInetAddress().toString();
            reader = new BufferedReader(new InputStreamReader(cSock.getInputStream()));
            writer = new PrintWriter(new OutputStreamWriter(cSock.getOutputStream()));
            writer.println("You are now connected to the Distibuted Simulation Server.");
            writer.flush();
            
            /* create threads for comunication with client */
            ServerWriteThread v_1 = new ServerWriteThread(writer, t_id, t_comm_data, t_gui); // vytvori vlakno
            ServerReadThread v_2 = new ServerReadThread(reader, t_id, t_comm_data, t_gui); // vytvori vlakno
            v_2.start();
            v_1.start();
            
            try {
                v_2.join();
                //System.out.println("join v2");
                v_1.join();
                //System.out.println("join v1");
            }
            catch (InterruptedException e){
                System.err.println("Exception: " + e.getMessage());
                System.exit(1);
            }
            
            
            System.out.println("Closing the client " + t_id  + " : "+ cSock.getInetAddress());
            
            reader.close();
            writer.close();
            cSock.close();
            //System.out.println("Closing the server"); // server.close ();
            if (t_comm_data.c_count == 0) {
                System.out.println("Closing the server"); // server.close ();
                t_comm_data.closeTraficFile();
                t_gui.jButton1.setEnabled(true);
                t_gui.jLabel16.setText("Simulation done");
                //System.exit(0);
            }
        } catch (IOException e1) {
            System.err.println("Exception: " + e1.getMessage());
            System.exit(1);
        }
    }
}



public class MainServer extends Thread {
    public final static int DEFAULT_PORT = 6789;
    private Socket client = null;
    private static int user_id = 0;
    private static ServerData t_comm_data;
    private ServerGui t_gui;
    
    public MainServer(ServerGui par_gui, ServerData par_comm_data ) {
        super("echo_Server_main");
        t_comm_data = par_comm_data;
        t_gui = par_gui;
    }
    
    public void run() {
        ServerSocket server = null;
        //t_comm_data = new server_data();
        
        try {
            server = new ServerSocket(DEFAULT_PORT);
            System.out.println("Starting on port " + DEFAULT_PORT);
            t_gui.jLabel17.setText("Starting on port " + String.valueOf(DEFAULT_PORT));
            t_gui.jLabel16.setText("Conecting");
            
        } catch (IOException e) {
            System.err.println("Exception: could't make server socket.");
            System.exit(1);
        }
        while (true) {
            Socket incomingSocket = null; // wait fot a connection request
            System.out.println("Waiting...");
            try {
                incomingSocket = server.accept(); // call a thread to deal with a connection
                ServerThread v = new ServerThread(incomingSocket, user_id, t_comm_data, t_gui); // vytvori vlakno
                user_id++;
                t_comm_data.c_count++;
                v.start();
            }
            catch (IOException e) {
                System.err.println("Exception: could't make server socket.");
                System.exit(1);
            }
        }
    }
}
