/*
 *  Deklaration of server's shared object mean buffers
 *  Jakub Pastyrik @
 *
 *
 */

import java.util.StringTokenizer;
import java.net.*;
import java.util.*;
import java.io.*;

/**
 *  This class contain data about users senders     <BR>
 *
 */
class SenderItem {
    public String senderName;
    private boolean order_last_event;
    
    /**
     *  Konstructor of item                         <BR>
     */
    public SenderItem(String ParSenderName) {
        senderName = ParSenderName;
        order_last_event = false;
    }
    
    /**
     *  set value of flag                           <BR>
     */
    public void setOrderLastEvent(boolean ParOrderSimOver){
        order_last_event = ParOrderSimOver;
        return;
    }
    
    /**
     *  return value of flag                        <BR>
     */
    public boolean getOrderLastEvent(){
        return(order_last_event);
    }
    
    
}


/**
 *
 *  This class contain all data about user          <BR>
 *  this items are stored in field  base            <BR>
 */
class ServerUserItem {
    
    public int flag;
    public int mess_count;      //  count of meesage in stack
    public int in_tot_count;    //  count of all incoming message
    public int out_tot_count;   //  count of all outgoinig message
    public int countOfAntiMessage; // count of Antimessage
    public int countOfUndo; // count of undo
    
    
    public boolean comm_ready;
    public boolean client_bussy;
    public boolean cexit_order;
    public boolean sim_over_order;
    public boolean server_bussy;
    public boolean bussy;
    
    public boolean order_last_time;
    public boolean order_last_event;
    public boolean order_sim_over;
    
    public boolean order_stop_all;
    public boolean order_stop;
    public boolean order_stop_ack;
    public boolean order_stop_exec;
    
    public boolean order_go_all;
    public boolean order_go;
    public boolean order_go_ack;
    public boolean order_go_exec;
    
    public ArrayList sendersField;
    
    public double localLBTS = 0.0;
    
    public StringBuffer client_name;
    
    public String clientAdrress;
    
    public ServerUserItem(){
        
        
        sendersField = new ArrayList();
        
        flag                = 0;
        mess_count          = 0;
        in_tot_count        = 0;
        out_tot_count       = 0;
        countOfAntiMessage  = 0; // count of Antimessage
        countOfUndo         = 0; // count of Undo
        
        cexit_order     = false;
        comm_ready      = false;
        
        order_last_time = false;
        order_last_event= false;
        order_sim_over  = false;
        
        order_stop_all  = false;
        order_stop      = false;
        order_stop_ack  = false;
        order_stop_exec = false;
        
        order_go_all    = false;
        order_go        = false;
        order_go_ack    = false;
        order_go_exec   = false;
        
        client_name     = new StringBuffer(10);
        clientAdrress   = new String();
    }
} // end class client_item

/**
 *  This class is item of not connect users     <BR>
 *
 */
class NotReadyUsers {
    
    private StringBuffer client_name;
    /**
     *  Konstructor                         <BR>
     *  Create new item of not ready user   <BR>
     *
     */
    public NotReadyUsers(String ParUserName){
        client_name = new StringBuffer(ParUserName);
    }
    
    /**
     *  this method get name from item      <BR>
     */
    
    public String getName() {
        return(client_name.toString());
    }
    
    
}
/**
 *  This Object contain parsed message
 */
class ServerMessageItem {
    public int flag;
    public boolean executed;
    public StringBuffer from;
    public double message_1;
    public double message_2;
    public StringBuffer to;
    public int gate;
    
    public ServerMessageItem(int ParFlag, String ParFrom, String ParTo, double ParMessage1, double ParMessage2, int ParGate) {
        flag        = ParFlag;
        executed    = false;
        from        = new StringBuffer(ParFrom);
        to          = new StringBuffer(ParTo);
        message_1   = ParMessage1;
        message_2   = ParMessage2;
        gate        = ParGate;
    }
    
    /**
     *  set flag executed                           <BR>
     */
    public void setExecuted(boolean ParExec) {
        this.executed = ParExec;
    }
    
}//end class ServerMessageItem

/**
 *  This class contain all buffer a shared fields   <BR>
 *  there are methods for access to variables       <BR>
 *
 */
public class ServerData{
    
    
    public final static int C_LEVEL = 10;   // max count of connected users
    
    public int c_count;                 // count of connected users
    
    public ServerUserItem[] base;       // field with users items
    
    public boolean stop_all;            // all users stoped_ack
    public boolean am_all;              // any anti messages
    public boolean go_all;              // all users go_ack
    
    public FileWriter fw;               // trafick file
    
    public ArrayList list_not_users;    // queue with not ready users
    public ArrayList queue;             // queue with events
    public ArrayList am_queue;          // queue with anti-messages
    
    private ServerGui t_gui;            // gui
    private String path;                // path to save files
    
    private long startTime = 0;         // start idle server time
    private long endTime = 1;           // end idle server time
    
    public long startSimTime    = Long.MAX_VALUE;
    public long endSimTime      = Long.MAX_VALUE;
    
    private int totalMessageCount = 0;  // total count of sended messages
    
    public boolean printOnScreen    = true;
    public boolean printToFile      = true;
    
    public long deadlockIdleTime    = 30;   // idle time
    
    /**
     *  Constructor of class stack_data <BR>
     *
     */
    public ServerData(ServerGui par_gui){
        int i;
        
        path            = new String();
        
        list_not_users  = new ArrayList();
        queue           = new ArrayList();
        am_queue        = new ArrayList();
        
        base            = new ServerUserItem[C_LEVEL];
        
        c_count         = 0;
        
        
        stop_all    = false;
        am_all      = false;
        go_all      = false;
        
        t_gui       = par_gui;
        
        for(i = 0; i < C_LEVEL; i++){
            base[i] = new ServerUserItem();
            base[i].flag = 0;
        }
        
        this.createTraficFile();
    }   // end  constructor
    
    
    /**
     *      This method get time how long is server     <BR>
     *      not working                                 <BR>
     *                                                  <BR>
     *      RV(long) .. time in milisekunds             <BR>
     *
     */
    
    public synchronized long getServerIdle() {
        long delta;
        endTime = System.currentTimeMillis();
        delta = endTime - startTime;
        System.out.println("Idle : " + (delta / 1000));
        if (this.totalMessageCount == 0) return(0);
        else if (this.stop_all == true) return(0);
        else return(delta);
    }
    
    
    /**
     *  This method return count of events for user     <BR>
     *                                                  <BR>
     *  PAR: (int) .. user id                           <BR>
     *                                                  <BR>
     *  RV: (int) .. count of events in stack           <BR>
     */
    synchronized public int getCountOfEvents(int ParUserId){
        int i;
        int count = 0;
        ServerMessageItem t_item;
        
        for(i = 0; i < this.queue.size(); i++){
            t_item = ((ServerMessageItem) this.queue.get(i));
            if (base[ParUserId].client_name.toString().equals(t_item.to.toString()) == true) {
                count++;
            }
        }
        //        System.out.println(base[ParUserId].client_name.toString() + " count "+  count);
        return(count);
    }
    
    
    /**
     *  This method comput GTV                          <BR>
     *                                                  <BR>
     *  RV: (double)    value of GVT                    <BR>
     */
    public synchronized double getGVT(){
        int i;
        double t_gtv = Double.MAX_VALUE;
        
        for(i = 0; i < this.C_LEVEL; i++) {
            if (base[i].flag == 1) {
                //System.out.print(base[i].client_name.toString() + " : " + base[i].localLBTS);
                if (base[i].out_tot_count != 0) {
                    if (base[i].localLBTS < t_gtv) {
                        t_gtv = base[i].localLBTS;
                    }
                }
            }
        }
        return(t_gtv);
    }
    
    
    /**
     *  This method delete all message in stack when    <BR>
     *  anti-message comin                              <BR>
     *                                                  <BR>
     *  PAR: (double) .. anti message time stamp        <BR>
     *      (string) .. receiver name                   <BR>
     *                                                  <BR>
     *  RV: (int) .. count of deleted messages          <BR>
     */
    synchronized public int eraseMessageWhenRollback(double ParTimeStamp, String ParReceiverName) {
        int count = 0;
        int i, t_length ;
        
        ServerMessageItem t_item;
        
        t_length = queue.size();
        for (i = 0; i < t_length; i++) {
            t_item = ((ServerMessageItem) queue.get((t_length - 1) - i));
            if (t_item.to.toString().equals(ParReceiverName) == true) {
                
                if ((t_item.message_1 > ParTimeStamp) && ((t_item.gate / 10) == 2)){
                    queue.remove((t_length - 1) - i);
                    count++;
                }
            }
        }
        for (i = 0; i < this.C_LEVEL; i++){
            if (base[i].client_name.toString().equals("ParReceiverName") == true) {
                base[i].mess_count = base[i].mess_count - count;
            }
        }
        return(count);
    }
    
    
    /**
     *
     *  This method add sender name to stack            <BR>
     *                                                  <BR>
     *  PAR: (int)  ..client ID                         <BR>
     *      (String) ..sender name                      <BR>
     *                                                  <BR>
     *  RV: (int)     1.. sucess                        <BR>
     *              -1.. item allready exist            <BR>
     */
    synchronized public int addSender(int ParClientId, String ParSenderName){
        int i;
        
        SenderItem t_item;
        
        for(i = 0; i < base[ParClientId].sendersField.size(); i++) {
            t_item = ((SenderItem) base[ParClientId].sendersField.get(i));
            if (t_item.senderName.equals(ParSenderName)) return(-1);
        }
        base[ParClientId].sendersField.add(new SenderItem(ParSenderName));
        return(1);
    }
    
    
    /**
     *
     *  This method set that sender simulation is done  <BR>
     *                                                  <BR>
     *  PAR:(int) ..    id name                         <BR>
     *      (boolean) .. done - true                    <BR>
     *                                                  <BR>
     *  RV: (int)     1.. sucess                        <BR>
     *              -1.. item not exist                 <BR>
     */
    synchronized public int setSenderLastEvent(int ParId, boolean ParSimDone){
        base[ParId].order_last_event = ParSimDone;
        return(1);
    }
    
    
    /**
     *
     *  This method check if all simulation of sender       <BR>
     *  are done                                            <BR>
     *  PAR: (int)  ..client ID                             <BR>
     *                                                      <BR>
     *  RV: (int)    0 ..   not ready yet                   <BR>
     *               1 ..   yes you can  send Last Time     <BR>
     *               2 ..   yes you must send Last Time     <BR>
     *                      deadlock situation occur        <BR>
     */
    synchronized public int checkAllSenderLastEvent(int ParClientId){
        int i, j;
        int flag = 1;
        int count = 0;
        
        SenderItem t_item;
        
        for(i = 0; i< C_LEVEL; i++) {
            for (j =0; j < base[i].sendersField.size(); j++) {
                t_item = ((SenderItem) base[i].sendersField.get(j));
                if (t_item.senderName.equals(base[ParClientId].client_name.toString()) == true) {
                    if (base[i].order_last_event == false) {
                        flag = -1;
                        //System.out.println(base[ParClientId].client_name + " waiting for Last_Event" + base[i].client_name);
                    }
                    else {
                        count++;
                        //System.out.println(base[ParClientId].client_name + " not waiting for Last_Event" + base[i].client_name);
                    }
                }
            }
        }
        //System.out.println("Server Idle for :" + getServerIdle());
        if (getServerIdle() > (this.deadlockIdleTime * 1000)) {
            System.out.println("Server Idle for :" + getServerIdle());
            return(2);
        }
        
        if ((flag == 1) && (count > 0))  return(1);
        else return(0);
    }
    
    
    /**
     *  This method create file with listing of all created             <BR>
     *  files, these files can be used for Post Mortal visualisation    <BR>
     *
     */
    private void createConfigFile(String ParPath) {
        File        fileAbs;
        FileWriter  fileConf;
        int i;
        
        fileAbs = new File(ParPath, "sim_config.txt");
        
        if (fileAbs.exists() == true) {
            fileAbs.delete();
        }
        try {
            fileAbs.createNewFile();
            fileConf = new FileWriter(fileAbs);
            for (i = 0; i < this.C_LEVEL; i++) {
                if (base[i].flag == 1) {
                    fileConf.write(this.base[i].client_name + "\n");
                    fileConf.write(ParPath +"\\"+ this.base[i].client_name + "_inqueue.txt\n");
                    fileConf.write(ParPath +"\\"+ this.base[i].client_name + "_outqueue.txt\n");
                    fileConf.write(ParPath +"\\"+ this.base[i].client_name + "_simul.txt\n");
                }
            }
            fileConf.close();
        }
        catch (IOException e){
            System.out.println("Can't create file");
        }
        
        
    }
    
    
    /**
     *  Create file for saving of all server trafic     <BR>
     *                                                  <BR>
     *  RV: (int) 1 .. file created succefully          <BR>
     *            -1 ..   can't  created file           <BR>
     */
    private int createTraficFile() {
        
        String  tempFilePath;
        String  tempFileName;
        File    tempFile;
        File    tempDir;
        
        tempFileName = new String("temp.txt");
        tempFilePath = new String();
        
        try {
            tempFile = new File(tempFileName);
            
            tempFilePath = tempFile.getAbsolutePath();
            tempFilePath = tempFilePath.substring(0, tempFilePath.length() - tempFileName.length());
            
            tempFilePath = tempFilePath + "temp";
            
            tempDir = new File(tempFilePath);
            
            // dir allready exist
            if (tempDir.exists() == true) {
                System.out.println("Dir allready exists ");
                this.path = tempFilePath;
                tempFilePath = tempFilePath + "\\";
                File absolute = new File(tempFilePath,"server_traffic.txt");
                System.out.println("Create file :" + absolute.getAbsolutePath());
                
                if (absolute.exists() == true) {
                    absolute.delete();
                }
                absolute.createNewFile();
                fw = new FileWriter(absolute);
            }
            else {// must create dir
                System.out.print("\nCreating dir .. ");
                if (tempDir.mkdir() == true) {
                    
                    System.out.println("done\n");
                    this.path = tempFilePath;
                    tempFilePath = tempFilePath + "\\";
                    File absolute = new File(tempFilePath,"server_traffic.txt");
                    System.out.println("Create file :" + absolute.getAbsolutePath());
                    
                    if (absolute.exists() == true) {
                        absolute.delete();
                    }
                    absolute.createNewFile();
                    fw = new FileWriter(absolute);
                }
                else {
                    System.out.println("failt\n");
                    System.exit(1);
                }
            }
        }
        catch (IOException f){
            System.out.println("Can't open or create file");
            return(-1);
        }
        return(1);
    }
    
    
    /**
     *  Close server login file                         <BR>
     *                                                  <BR>
     *  RV: (int) 1 .. file closed succefully           <BR>
     *            -1 ..   can't  close file             <BR>
     */
    public int closeTraficFile() {
        try {
            fw.close();
        }
        catch (IOException e){
            System.out.println("Can't close file input stream");
            return(-1);
        }
        return(1);
    }
    
    
    /**
     *  Write to server login file or on screen         <BR>
     *                                                  <BR>
     * Par: (String) ParLine .. Input text              <BR>
     *                                                  <BR>
     */
    public void writeToFile(String ParLine) {
        try {
            if (this.printToFile == true) fw.write(ParLine + "\n");
            if (this.printOnScreen == true) System.out.println(ParLine);
        }
        catch (IOException e){
            System.out.println("Can't write in");
        }
        return;
    }
    
    
    /**
     *
     *  Store parts of anti message to Buffer               <BR>
     *                                                      <BR>
     *  PAR:    (int) ParFlag .. kind of meesage            <BR>
     *          (String) ParFrom .. message sender          <BR>
     *          (String) ParTo .. message receiver          <BR>
     *          (double) ParMessage1 .. time stamp 1        <BR>
     *          (double) ParMessage2 .. time stamp 2        <BR>
     *                                                      <BR>
     */
    synchronized public void storeToAMQueue(int ParFlag, String ParFrom, String ParTo, double ParMessage1, double ParMessage2, int ParGate) {
        int i;
        i = this.getUserId(ParFrom);
        if (i > 0) base[i].countOfAntiMessage++;
        am_queue.add(new ServerMessageItem(ParFlag, ParFrom, ParTo, ParMessage1, ParMessage2, ParGate));
        //System.out.println("Store To AM("+queue.size()+") :" + ParMessage1);
    }
    
    
    /**
     *
     *  Erase item from Anti-Message queue                  <BR>
     *                                                      <BR>
     *  PAR: (double) ParMessage .. time stamp of anti-m.   <BR>
     *                                                      <BR>
     *  RV: (Inr) 1 .. antimessage erased succefully        <BR>
     *            -1 .. can't find antimessage              <BR>
     */
    synchronized public int eraseAMFromQueue(double ParMessage) {
        int i, index = -1;
        ServerMessageItem t_item;
        
        for(i = 0; i < am_queue.size(); i++){
            t_item = ((ServerMessageItem) am_queue.get(i));
            if (t_item.message_1 == ParMessage) {
                index = i;
                break;
            }
        }
        if (index == -1) return(-1);
        else {
            am_queue.remove(index);
            //System.out.println("Erase from AM("+am_queue.size()+") :" + ParMessage);
            return(1);
        }
    }
    
    
    /**
     *  Get index of item with lowest time stamp            <BR>
     *                                                      <BR>
     *  Par: (String) ParName .. receiver name              <BR>
     *                                                      <BR>
     *  RV: (ind) .. index of message in queue              <BR>
     *
     */
    synchronized private int getIndexOfAM(String ParName) {
        int i, index = -1;
        double lowest = Double.MAX_VALUE;
        ServerMessageItem t_item;
        
        for(i = 0; i < am_queue.size(); i++) {
            t_item = ((ServerMessageItem) am_queue.get(i));
            if ((t_item.to.toString().equals(ParName) == true) && (t_item.executed == false)) {
                t_item.setExecuted(true);
                index = i;
                break;
            }
        }
        return(index);
    }
    
    
    /**
     *  Load message with lowest time stamp from queue      <BR>
     *                                                      <BR>
     *  Par:    (int) ParId .. receiver id                  <BR>
     *                                                      <BR>
     *  RV:     (MessageItem) .. message                    <BR>
     *                                                      <BR>
     */
    synchronized public ServerMessageItem loadFromAMQueue(int ParId) {
        int i;
        ServerMessageItem t_item;
        
        i = this.getIndexOfAM(base[ParId].client_name.toString());
        if (i == -1) return(null);
        else {
            t_item = new ServerMessageItem(0, "null", "null", 0.0, 0.0, 0);
            t_item = ((ServerMessageItem) am_queue.get(i));
            return(t_item);
        }
    }
    
    
    /**
     *
     *  Store parts of message to Buffer                    <BR>
     *                                                      <BR>
     *  PAR:    (int) ParFlag .. kind of meesage            <BR>
     *          (String) ParFrom .. message sender          <BR>
     *          (String) ParTo .. message receiver          <BR>
     *          (double) ParMessage1 .. time stamp 1        <BR>
     *          (double) ParMessage2 .. time stamp 2        <BR>
     *                                                      <BR>
     */
    synchronized private void storeToQueue(int ParFlag, String ParFrom, String ParTo, double ParMessage1, double ParMessage2, int ParGate) {
        queue.add(new ServerMessageItem(ParFlag, ParFrom, ParTo, ParMessage1, ParMessage2, ParGate));
        // System.out.println("Store To("+queue.size()+") :" + ParMessage1);
    }
    
    
    /**
     *  Get index of item with lowest time stamp            <BR>
     *                                                      <BR>
     *  Par: (String) ParName .. receiver name              <BR>
     *                                                      <BR>
     *  RV: (ind) .. index of message in queue              <BR>
     *
     */
    synchronized private int getIndexOfMessage(String ParName) {
        int i, index = -1;
        double lowest = Double.MAX_VALUE;
        ServerMessageItem t_item;
        
        for(i = 0; i < queue.size(); i++) {
            t_item = ((ServerMessageItem) queue.get(i));
            if (t_item.to.toString().equals(ParName) == true) {
                if (t_item.message_1 < lowest) {
                    lowest = t_item.message_1;
                    index = i;
                }
            }
        }
        return(index);
    }
    
    
    /**
     *  Are in queue any messages for user                  <BR>
     *                                                      <BR>
     *  Par: (String) ParName .. receiver name              <BR>
     *  RV : true .. yes in stack is message for u.         <BR>
     *       false .. no isn't                              <BR>
     */
    synchronized public boolean anyMessageNotSended(String ParName){
        int i;
        ServerMessageItem t_item;
        
        for(i = 0; i < queue.size(); i++) {
            t_item = ((ServerMessageItem) queue.get(i));
            if (t_item.to.toString().equals(ParName) == true) {
                return(true);
            }
        }
        return(false);
    }
    
    
    /**
     *  Load message with lowest time stamp from queue      <BR>
     *                                                      <BR>
     *  Par:    (int) ParId .. receiver id                  <BR>
     *                                                      <BR>
     *  RV:     (MessageItem) .. message                    <BR>
     *                                                      <BR>
     */
    synchronized private ServerMessageItem loadFromQueue(int ParId) {
        int i;
        ServerMessageItem t_item;
        
        i = this.getIndexOfMessage(base[ParId].client_name.toString());
        if (i == -1) return(null);
        else {
            t_item = new ServerMessageItem(0, "null", "null", 0.0, 0.0, 0);
            t_item = ((ServerMessageItem) queue.get(i));
            queue.remove(i);
            return(t_item);
        }
    }
    
    
    /**
     *
     *  Add user to list of not yet ready users             <BR>
     *                                                      <BR>
     *  PAR : (String) .. user name                         <BR>
     *
     */
    synchronized public void addNotReadyUser(String ParUserName) {
        int i, x = 0;
        
        for(i = 0; i < this.getCountOfNotReadyUsers(); i++) {
            if (((NotReadyUsers) list_not_users.get(i)).getName().equals(ParUserName))
                x++;
        }
        if (x == 0) list_not_users.add(new NotReadyUsers(ParUserName));
        return;
    }
    
    
    /**
     *  This methot get count of not ready users            <BR>
     *                                                      <BR>
     *  RV: (int) count of not ready users                  <BR>
     *
     */
    synchronized private int getCountOfNotReadyUsers() {
        return(list_not_users.size());
    }
    
    
    /**
     *
     *  get user index in list of not ready users           <BR>
     *  PAR : (String) ParUserName .. user name             <BR>
     *  RV  :  (int)    index                               <BR>
     *
     */
    synchronized private int getIndexOfNotReadyUser(String ParUserName) {
        int i;
        for(i = 0; i < this.getCountOfNotReadyUsers(); i++) {
            if (((NotReadyUsers) list_not_users.get(i)).getName().equals(ParUserName))
                return(i);
        }
        return(-1);
    }
    
    
    /**
     *
     *  Is this user in ready list ?                        <BR>
     *                                                      <BR>
     *  PAR (String)   par_name .. user name                <BR>
     *  RV: (int)                                           <BR>
     *          1 .. yes                                    <BR>
     *          -1 .. no                                    <BR>
     */
    synchronized public int isUserInReadyList(String par_name) {
        int i;
        
        for (i = 0; i < C_LEVEL; i++){
            if (base[i].flag == 1) {
                if (base[i].client_name.toString().equals(par_name) == true)
                    return(1);
            }
        }
        return(-1);
    }
    
    
    /**
     *  All clients send order stop_ack                     <BR>
     *                                                      <BR>
     * RV: (int) 1 .. yes                                   <BR>
     *          -1 .. no                                    <BR>
     */
    synchronized public int allClientsStopAck() {
        int i, j = 0, k = 0;
        
        for (i = 0; i < C_LEVEL; i++){
            if (base[i].flag == 1) {
                j++;
                if (base[i].order_stop_ack == true)
                    k++;
            }
        }
        if ((j == k) && (j != 0)) return(1);
        else return(-1);
    }
    
    
    /**
     *  all simulation over                                 <BR>
     *                                                      <BR>
     *  RV: (int) 1 .. yes                                  <BR>
     *          -1 .. no                                    <BR>
     */
    synchronized public int allClientsSimOver() {
        int i, j = 0, k = 0;
        
        for (i = 0; i < C_LEVEL; i++){
            if (base[i].flag == 1) {
                j++;
                if (base[i].order_sim_over == true)
                    k++;
            }
        }
        if ((j == k) && (j != 0)) return(1);
        else return(-1);
    }
    
    
    /**
     *  All clients send order go_ack                       <BR>
     *                                                      <BR>
     * RV: (int) 1 .. yes                                   <BR>
     *          -1 .. no                                    <BR>
     */
    synchronized public int allClientsGoAck() {
        int i, j = 0, k = 0;
        
        for (i = 0; i < C_LEVEL; i++){
            if (base[i].flag == 1) {
                j++;
                if (base[i].order_go_ack == true)
                    k++;
            }
        }
        if ((j == k) && (j != 0)) return(1);
        else return(-1);
    }
    
    
    /**
     *  seting all flag involved to stop&go simulation      <BR>
     */
    synchronized public void allFlagsSet() {
        int i;
        
        for (i = 0; i < C_LEVEL; i++){
            
            if (base[i].flag == 1) {
                
                base[i].order_go        = false;
                base[i].order_go_ack    = false;
                base[i].order_go_all    = false;
                base[i].order_go_exec   = false;
                
                base[i].order_stop      = false;
                base[i].order_stop_ack  = false;
                base[i].order_stop_all  = false;
                base[i].order_stop_exec = false;
                
            }
        }
        return;
    }
    
    
    /**
     *  Are all clients ready?                              <BR>
     *                                                      <BR>
     *  RV:     (int) 1 .. all ready                        <BR>
     *               -1 .. no                               <BR>
     */
    public int allClientsReady() {
        int i, ready = 0;
        
        for(i = 0; i < C_LEVEL; i++){
            if (base[i].flag == 1) ready++;
        }// end for
        
        
        if ((this.getCountOfNotReadyUsers() == 0) && (ready > 1)) {
            this.createConfigFile(this.path);
            //            startTime =  System.currentTimeMillis();
            return(1);
        }
        else
            return(-1);
    }
    
    
    /**
     *      This method return ID of user                   <BR>
     *                                                      <BR>
     *      PAR :  (String) user name                       <BR>
     *                                                      <BR>
     *      Return Value: (int)  user ID from variable base <BR>
     *                      -1  user not found  <BR>        <BR>
     */
    synchronized public int getUserId(String par_user_name){
        int i;
        
        for(i = 0; i < C_LEVEL; i++){
            if ((base[i].client_name.toString().equals(par_user_name)) == true)
                return(i);
        }
        return(-1);
    }
    
    
    /**
     *  store user to ready-user list                       <BR>
     *  if user is in not-ready-user list his item          <BR>
     *  is erased                                           <BR>
     *                                                      <BR>
     *  PAR:    (int) par_id .. user id                     <BR>
     *          (String) par_name .. user name              <BR>
     *                                                      <BR>
     *  RV:     (int)                                       <BR>
     */
    synchronized public int storeClient(int par_id, String par_name) {
        int i;
        
        i = this.getIndexOfNotReadyUser(par_name);
        if (i != -1) list_not_users.remove(i);
        
        if (base[par_id].flag == 0) {
            t_gui.jComboBox1.addItem(par_name);
            base[par_id].client_name.append(par_name);
            base[par_id].flag = 1;
        }
        
        return(1);
    }
    
    
    /**
     *  Print list of all clients and his status            <BR>
     */
    synchronized public void dropTable() {
        int i;
        
        System.out.println("Active");
        for(i = 0; i < C_LEVEL; i++){
            if  (base[i].flag != 0) System.out.println("drop :"+base[i].client_name+ " : "+ base[i].mess_count+ " : "+ base[i].flag);
        }
        System.out.println("Pactive :");
        for(i = 0; i < this.getCountOfNotReadyUsers(); i++){
            System.out.print(" ," + ((NotReadyUsers) list_not_users.get(i)).getName());
        }
        System.out.print("\n");
        return;
    }
    
    
    /**
     * Unlock all users                                     <BR>
     */
    synchronized public void unlock(){
        
        notifyAll();
    }
    
    
    /**
     *  Get the message with lowest time_stamp from shared server's memory      <BR>
     *                                                                          <BR>
     *  PAR :   (int)   par_id .. reveiver id                                   <BR>
     *                                                                          <BR>
     *  RETURN VALUE : (server_message_item)                                    <BR>
     *                  or null if something wrong                              <BR>
     *                                                                          <BR>
     */
    synchronized public ServerMessageItem get(int par_id){
        ServerMessageItem t_item;
        
        
        //        while((base[par_id].mess_count == 0) && (base[par_id].cexit_order == false)){
        while((getCountOfEvents(par_id) == 0) && (base[par_id].cexit_order == false)){
            try {
                System.out.println("Wait untill had any massage to send");
                System.out.flush();
                wait();
            }
            catch (InterruptedException e) { }
        }
        if ((getCountOfEvents(par_id) == 0) && (base[par_id].cexit_order == true)){
            System.out.println("order cexit from user executed");
            notifyAll();
            return(null);
        }
        base[par_id].mess_count--;
        base[par_id].in_tot_count++;
        if (this.allClientsReady() == 1) startTime = System.currentTimeMillis();
        t_item = this.loadFromQueue(par_id);
        //System.out.println("Load("+ queue.size() +") :" +  t_item.message_1);
        
        notifyAll();
        
        return(t_item);
        
    }
    
    
    /**
     *  storing message to stack and inc message counter                        <BR>
     *                                                                          <BR>
     *  par_item contain flag of message, sender name, message, receiver name   <BR>
     *                                                                          <BR>
     *  Return Value : (int)                                                    <BR>
     *                                                                          <BR>
     *      1 .. saved sucesfully                                               <BR>
     *
     */
    synchronized public int put(ServerMessageItem par_item, int par_id){
        int j;
        
        for(j = 0; j < C_LEVEL; j++) {
            if (base[j].client_name.toString().equals(par_item.to.toString()) == true){
                base[j].mess_count++;
                break;
            }
        }
        if ((this.queue.size() == 0) && (this.allClientsReady()==1))startTime = System.currentTimeMillis();
        
        this.totalMessageCount++;
        base[par_id].out_tot_count++;
        this.storeToQueue(par_item.flag, par_item.from.toString(), par_item.to.toString(), par_item.message_1, par_item.message_2, par_item.gate);
        
        notifyAll();
        return(1);
    }
    
}// end class