import java.net.*;
import java.io.*;
import java.util.StringTokenizer;

/*
 * par_read_thread.javareadStream

/**
 *
 * @author  Kuba
 */

public class ServerReadThread extends Thread {
    
    private BufferedReader readStream;
    private int         id;
    private ServerData  data;
    private ServerGui  gui;
    
    public ServerReadThread(BufferedReader ParReader, int ParId, ServerData ParData, ServerGui ParGui) {
        
        super("par_read_thread");
        
        readStream  = ParReader;
        id          = ParId;
        data        = ParData;
        gui         = ParGui;
    }
    
    /**
     *
     *  Main Reading Loop With Branching    <BR>
     *
     *
     *
     */
    
    public void run() {
        String r_line;
        int r_status = 0;
        
        for (;;) {
            
            try {
                r_line = readStream.readLine(); // read a line
            }
            catch (IOException e1) {
                System.err.println("Exception: " + e1.getMessage());
                break;
            } //end catch
            
            r_status = getMessageStatus(r_line, id);
            
            if  (r_status != 1)
                //System.out.println("Status: " + r_status +" Client says: " + r_line);
            
            // mesage saved
            if (r_status ==  1) {
                //System.out.println("Saved");
                if (data.stop_all == false)
                    gui.jLabel16.setText("Message Exchanging");
                gui.jLabel4.setText(String.valueOf(data.queue.size()));
            }
            
            // Connection Broken
            if (r_status ==  -1) {
                System.out.println("Null - Breaking");
                break;
            }
            
            // can't store meesage
            if (r_status ==  -2) {
                System.out.println("Server stack full");
                break;
            }
            
            // Order Cexit
            if (r_status == -3){
                gui.jLabel16.setText("Simulation closing");
                data.writeToFile("------ User Statistic -------");
                data.writeToFile("Client: " + data.base[id].client_name + " Closed Output Stream");
                data.writeToFile("Total Count Incoming Message's: " + data.base[id].in_tot_count);
                data.writeToFile("Total Count Outgoing Message's: " + data.base[id].out_tot_count);
                data.writeToFile("------ User Statistic Over -------");
                data.base[id].cexit_order = true;
                data.base[id].flag = 1;
                data.unlock();
                data.c_count--;
                break;
            }
            
            // Order Drop
            if (r_status ==  -4) {
                data.dropTable();
            }
            
            // Comm_ready
            if (r_status ==  -6) {
                data.writeToFile("Message <-  " + r_line);
                gui.jLabel2.setText(String.valueOf(data.c_count));
                data.dropTable();
            }
            
            // ALL_STOP
            if (r_status ==  -7) {
                data.base[id].order_stop_all = true;
                data.base[id].order_stop_ack = true;
                data.base[id].countOfUndo++;                
                data.stop_all = true;
                gui.jLabel16.setText("Stop All");
                data.writeToFile("Server recv STOP_ALL from client:" + data.base[id].client_name);
            }
            
            // Last_time
            if (r_status ==  -8) {
                gui.jLabel2.setText(String.valueOf(data.c_count));
                data.setSenderLastEvent(id, true);
                data.writeToFile("Server recv LAST_TIME from client:" + data.base[id].client_name);
                //data.dropTable();
            }
            
            // STOP_ACK
            if (r_status ==  -9) {
                data.base[id].order_stop_ack = true;
                data.writeToFile("Server recv STOP_ACK from client:" + data.base[id].client_name);
            }
            
            // GO_ALL
            if (r_status ==  -10) {
                data.base[id].order_go_all = true;
                data.base[id].order_go_ack = true;
                data.go_all = true;
                gui.jLabel16.setText("Go All");               
                data.writeToFile("Server recv GO_ALL from client:" + data.base[id].client_name);
            }
            
            // GO_ACK
            if (r_status ==  -11) {
                data.base[id].order_go_ack = true;
                data.writeToFile("Server recv GO_ACK from client:" + data.base[id].client_name);
            }
            
            // ANTI - MESSAGE
            if (r_status ==  -12) {
                data.am_all = true;
                gui.jLabel16.setText("Anti - message");
                data.writeToFile("AntiMessage <- " + r_line);
            }
            
            // ANTI - MESSAGE ACK
            if (r_status ==  -13) {
                data.writeToFile("Server recv AM_ACK from client:" + data.base[id].client_name);
            }
            
            // SIM_OVER
            if (r_status ==  -14) {
                data.base[id].order_sim_over = true;
                data.writeToFile("Server recv SIM_OVER from client:" + data.base[id].client_name);
            }
            
            // rest
            if (r_status ==  -20) {
                System.out.println("---------- unknown situation ----------------");
                data.writeToFile("- US -" + data.base[id].client_name);
            }
            
        }
    } // end run
    
    /**
     *  checking incoming message and store if nessesary        <BR>
     *                                                          <BR>
     *  PAR :                                                   <BR>
     *          (int)           ParId .. user identification    <BR>
     *          (String)        ParLine .. incoming message     <BR>
     *                                                          <BR>
     *  RETURN VALUE:   (int)                                   <BR>
     *          1 .. message, stored to stack                   <BR>
     *          -1 .. null conection broken                     <BR>
     *          -2 .. error during saving message (stack full)  <BR>
     *          -3 .. order cexit                               <BR>
     *          -4 .. order drop                                <BR>
     *          -5 .. client_bussy no more messages for him     <BR>
     *          -6 .. order ready                               <BR>
     *          -7 .. can't convert time stamp                  <BR>
     *          -8 .. order sim_over                            <BR>
     *          -10 .. unsuported order                         <BR>
     */
    
    private int getMessageStatus(String ParLine, int ParId){
        
        String[] token;
        ServerMessageItem t_message;
        StringTokenizer st;
        double d_1, d_2;
        double t_lbts = 0.0;
        int i = 0, crc = 0, erno = -10, j = 0, k = 0, gate = 0;
        float usage , p;
        
        token = new String[10];
        
        st = new StringTokenizer(ParLine,":");
        
        Runtime r = Runtime.getRuntime();
        
        if (ParLine == null) return(-1);
        
        while(st.hasMoreTokens()){
            token[i] = new String(st.nextToken());
            i++;
        }
        
        try { // get first flag
            crc = Integer.valueOf(token[0]).intValue();
        }
        catch (NumberFormatException e) {
            System.out.println("Can't convert message flag");
            crc = 5;
        }
        
        // it's message
        if (crc == 1) {
            
            data.writeToFile("Message <-  "+ ParLine);
            
            try {
                d_1 = Double.valueOf(token[2]).doubleValue();
                d_2 = Double.valueOf(token[3]).doubleValue();
                gate = Integer.valueOf(token[5]).intValue();
                t_lbts = Double.valueOf(token[6]).doubleValue();
                if ((gate / 10) == 1) t_lbts = d_1;
            }                
            catch (NumberFormatException e) {
                System.out.println("Can't convert value");
                return(-20);
            }
            
            data.base[id].localLBTS = t_lbts;
            data.writeToFile("GVT :" + data.getGVT());
            gui.jLabel22.setText(String.valueOf(data.getGVT()));
            t_message = new ServerMessageItem(1,token[1], token[4], d_1, d_2, gate);
            data.put(t_message, id);
            erno = 1;
        }
        
        // its order
        if (crc == 2) {
            if (token[2].equals("cexit")) erno = -3;
            if (token[2].equals("drop")) erno = -4;
            if (token[2].equals("client_bussy")) erno = -5;
            
            if (token[2].equals("comm_ready")) {
                erno = -6;
                data.storeClient(id, token[1]);
                for (j = 3; j < i; j++) {
                    if (token[j].toString().equals("no") != true) {
                        data.addSender(id, token[j]);
                        if (data.isUserInReadyList(token[j]) == -1) {
                            data.addNotReadyUser(token[j]);
                        }
                    }
                }
            }
            
            if (token[2].equals("last_time")) {
                j = data.getUserId(token[3]);
                if (j != -1) {
                    data.base[j].order_last_time = true;
                    erno = -8;
                }
                else erno = -20;
            }
            if (token[2].equals("stop_all")) erno = -7;
            if (token[2].equals("stop_ack")) erno = -9;
            if (token[2].equals("go_all")) erno = -10;
            if (token[2].equals("go_ack")) erno = -11;
            if (token[2].equals("sim_over")) erno = -14;
        }
        // anti message
        if (crc == 3) {
            // antimessage
            if (token[2].equals("anti_message")) {
                try {
                    d_2 = Double.valueOf(token[3]).doubleValue();
                }
                catch (NumberFormatException e) {
                    System.out.println("Can't convert variable");
                    return(-20);
                }
                int kk;
                kk = data.eraseMessageWhenRollback(d_2, token[4]);
//                System.out.println("Count of erased messages :" + kk);
                data.storeToAMQueue(1, token[1], token[4], d_2, 0.0, 0);
                erno = -12;
            }
            // antimessage ack
            if (token[2].equals("anti_message_ack")) {
                try {
                    d_2 = Double.valueOf(token[3]).doubleValue();
                }
                catch (NumberFormatException e) {
                    System.out.println("Can't convert value");
                    return(-20);
                }
                k = data.eraseAMFromQueue(d_2);
                if (k == 1) {
//                    System.out.println("Anti - mesage -ack");
//                    System.out.flush();
                    erno = -13;
                }
                else {
//                    System.out.println("not found stamp");
                    erno = -20;
                }
            }
        }
        
        // its synch offer
        if ((crc == 5)  && (token[2].equals("nop"))) erno = 2;
        
        // free memory
        t_message = null;
        token = null;
        System.gc();
        
        p = r.totalMemory();
        usage = (r.freeMemory() / p) * 100 ;
        
        gui.jLabel4.setText(String.valueOf(data.queue.size()));
        gui.jLabel7.setText(String.valueOf(100 - usage)+ " %");
        gui.jLabel5.setText(String.valueOf(r.freeMemory()));
        gui.jLabel10.setText(String.valueOf(r.totalMemory()));
        
        return(erno);
        
    }// end check
    
    
    
}// end class
