import java.net.*;
import java.io.*;

/*
 * par_write_thread.java
 *
 * Created on 20. bezen 2004, 17:47
 */

/**
 *
 * @author  Kuba
 */
public class ServerWriteThread extends Thread {
    
    private String line;
    private PrintWriter writerStream;
    private int id;
    private ServerData data;
    private ServerGui gui;
    
    public ServerWriteThread(PrintWriter ParWriter, int ParId, ServerData ParData, ServerGui ParGui) {
        
        super("par_write_thread");
        
        writerStream    = ParWriter;
        id              = ParId;
        data            = ParData;
        gui             = ParGui;
        
    }
    
    public void run() {
        int j = 0, k = 0;
        // order comm_ready
        boolean cr_exec = false;
        // order_sim_over
        boolean so_exec = false;
        // order last_time 
        boolean lt_exec = false;
        // order_stop_all_ack
        boolean os_ack_exec = false;
        for (;;) {
            
            
            /** STOP
             *  sendig to stop order to the simulation
             */
            if ((data.stop_all == true) && (data.base[id].order_stop_exec == false)) {
                if (data.base[id].order_stop_all == false) {
                    data.base[id].order_stop = true;
                    writerStream.println(assembleNewMessage(-4, id)); // and send back ACK
                    writerStream.flush();                    
                    data.writeToFile("Server send STOP to client:" + data.base[id].client_name);                
                    data.base[id].order_stop_exec = true;                
                }
            }
            
            /** STOP_ALL_ACK
             *  all simulations are stoped
             */
            if ((data.base[id].order_stop_all == true) && (data.allClientsStopAck() == 1) &&
            (os_ack_exec == false)) {
                writerStream.println(assembleNewMessage(-9, id)); // and send back ACK
                writerStream.flush();
                data.writeToFile("Server send STOP_ALL_ACK to client:" + data.base[id].client_name);                
                os_ack_exec = true;
            }
            
            /** ANTI_MESSAGE
             *
             **/
            if (data.am_all == true) {
                line = assembleNewMessage(-11, id);
                if (line != null)  {
                    writerStream.println(line); // and send back ACK
                    writerStream.flush();                    
                    data.writeToFile("AntiMessage -> : " + line);                
                }
                else {
                    //System.out.println("No am for you :");
                    thread_sleep(150);
                }
            }
            /** ANTI_MESSAGE_ACK
             * antimessages echangin finished all simulation in stable state
             */
            if ((data.am_queue.size() == 0) && (data.base[id].order_stop_all == true) &&
            (data.am_all == true)){
                
                writerStream.println(assembleNewMessage(-12, id)); 
                writerStream.flush();
                data.writeToFile("Server send AM_ALL_ACK to client:" + data.base[id].client_name);                
                data.am_all = false;
            }
            
            /** GO
             *  release all stoped simulation 
             */
            if ((data.go_all == true) && (data.base[id].order_go_exec == false) && (data.allClientsStopAck() == 1)) {
                if (data.base[id].order_go_all == false) {
                    writerStream.println(assembleNewMessage(-5, id)); // and send back ACK
                    writerStream.flush();
                    data.writeToFile("Server send GO to client:" + data.base[id].client_name);                
                    data.base[id].order_go_exec = true;                
                }
            }
            
            /** GO_ALL_ACK
             * all simulations are released
             */
            if ((data.allClientsStopAck() == 1) && (data.allClientsGoAck() == 1) && data.base[id].order_go_all == true) {
                writerStream.println(assembleNewMessage(-10, id)); // and send back ACK
                writerStream.flush();
                data.writeToFile("Server send GO_ALL_ACK to client:" + data.base[id].client_name);                
                data.go_all = false;
                data.stop_all = false;
                data.allFlagsSet();
                os_ack_exec = false;
            }
                                    
            /** CEXIT
             *  Server accept client leaving from distributed simulation
             */
            if (data.base[id].cexit_order == true) {
                System.out.println("Server was runin for :" + ((data.endSimTime - data.startSimTime) / 1000));
                writerStream.println(assembleNewMessage(-3, id)); // and send back ACK
                writerStream.flush();
                data.writeToFile("Server closed input stream for client:" + data.base[id].client_name);
                gui.jLabel17.setText(String.valueOf("Client " + data.base[id].client_name + " say bye"));
                break;
            }
            
            /** LAST_TIME x LAST_EVENT_DEADLOCK
             *  there is'nt no more messages for this client
             * 
             */
              if ((data.getCountOfEvents(id) == 0) && 
                (data.checkAllSenderLastEvent(id) != 0) && (lt_exec == false)) {
                 if (data.checkAllSenderLastEvent(id) == 1)
                    line = assembleNewMessage(-8, id);
                 else
                    line = assembleNewMessage(-14, id);
                data.writeToFile("Server send LAST_TIME to client:" + data.base[id].client_name);
                writerStream.println(line);
                writerStream.flush();
                lt_exec = true;
            }
            
            /** SIM_OVER_ACK
             *  this mean that all simulation are over and no more
             *  messages in server queue
             */
            if ((data.allClientsSimOver() == 1) && (data.queue.size() == 0) && 
            (so_exec == false)){
                if (System.currentTimeMillis() < data.endSimTime) {
                    data.endSimTime = System.currentTimeMillis();
                }
                line = assembleNewMessage(-13, id);
                data.writeToFile("Server send SIM_OVER_ACK to client:" + data.base[id].client_name);
                writerStream.println(line);
                writerStream.flush();
                so_exec = true;
            }
            
            if (so_exec == true) {
                thread_sleep(150);
            }
            
            /** READY x NOT_READY
             *
             */
            if (data.base[id].comm_ready == false) {
                
                gui.jLabel16.setText("Synchronizing");
                
                if (data.allClientsReady() == 1) {                    
                    data.base[id].comm_ready = true;
                    writerStream.println(assembleNewMessage(-7, id));
                    writerStream.flush();
                    if (System.currentTimeMillis() < data.startSimTime) {
                        data.startSimTime = System.currentTimeMillis();
                    }
                    data.writeToFile("Server send READY to Client: "+ data.base[id].client_name);   
                }
                else {
                    if (cr_exec == false) {
                        writerStream.println(assembleNewMessage(-6, id)); // and send back ACK                        
                        writerStream.flush();
                        data.writeToFile("Server send NOT_READY to Client: "+ id);   
                        cr_exec = true;
                    }
                    thread_sleep(50);
                }
            }
            /** MESSAGE
             *  message exchanging
             */
            else {
                if ((data.stop_all == false) && (data.go_all == false)) {
                    
                    if ((data.stop_all == false) && (data.base[id].cexit_order == false))                    
                        gui.jLabel16.setText("Message Exchanging");                    
                    
//                    if (data.base[id].mess_count > 0) {
                      if (data.getCountOfEvents(id) > 0) {
                        k = 0;
                        line = null;
                        line = assembleNewMessage(1, id);
                        data.writeToFile("Message ->  " + line);
                        if (line == null) {
                            data.dropTable();
                            System.out.println("can get item from stack");
                        }
                        else {
                            gui.jLabel4.setText(String.valueOf(data.queue.size()));
                            writerStream.println(line);
                            writerStream.flush();
                        }
                    }
                    else {
                        //System.out.println(data.base[id].client_name + " no Message");
                        thread_sleep(100);
                    }
                }
                else {
                    //System.out.println(data.base[id].client_name + " stoping");
                    thread_sleep(100);
                }
            }
        } // ned for
    } // end run
    
    
    /**
     *
     *  Make thread sleep for while         <BR>
     *                                      <BR>
     *  Par: (int) .. sleep for time        <BR>
     *
     */
    
    private void thread_sleep(int par_time_to_sleep) {
        try {
            Thread.sleep(par_time_to_sleep);
        }
        catch (InterruptedException e){
            System.err.println("Exception: " + e.getMessage());
        }
        
    }
    
    
    
    /**
     *
     *  This method create new message                      <BR>
     *                                                      <BR>     
     *  Par:    (int) .. user id                            <BR>     
     *          (int) .. Message status                     <BR>
     *          1 .. message                                <BR>
     *         -3 .. cexit                                  <BR>     
     *         -4 .. stop                                   <BR>
     *         -5 .. go                                     <BR>
     *         -6 .. not_ready                              <BR>     
     *         -7 .. ready                                  <BR>
     *         -8 .. last_time                              <BR>     
     *         -9 .. stop_all_ack                           <BR>
     *         -10.. go_all_ack                             <BR>
     *         -11.. anti_message                           <BR>     
     *         -12.. anti_all_ack                           <BR>
     *         -13.. sim_over                               <BR>
     *                                                      <BR>     
     *  Return value:   (String) .. assembled message       <BR>
     *                  null    .. something wrong          <BR>
     *
     */
    private String assembleNewMessage(int ParStatus, int ParId){
        StringBuffer        t_buffer;
        ServerMessageItem   t_item;
        
        t_buffer = new StringBuffer(160);
        t_buffer.delete(0, t_buffer.length());
        
        
        if (ParStatus == 1) {
            t_item = data.get(ParId);
            if (t_item != null) {
                t_buffer.append("1:");
                t_buffer.append(t_item.from.toString());
                t_buffer.append(":");
                t_buffer.append(t_item.message_1);
                t_buffer.append(":");
                t_buffer.append(t_item.message_2);
                t_buffer.append(":");
                t_buffer.append(t_item.to.toString());
                t_buffer.append(":");
                t_buffer.append(t_item.gate);
            }
            else
                return(null);
        }
        if (ParStatus == 2) {
            t_buffer.append("3:server:nop:client");
        }
        if (ParStatus == -3) {
            t_buffer.append("2:server:cexit:client");
        }
        if (ParStatus == -4) {
            t_buffer.append("2:server:stop:client");
        }
        
        if (ParStatus == -5) {
            t_buffer.append("2:server:go:client");
        }
        
        if (ParStatus == -6) {
            t_buffer.append("2:server:not_ready:client");
        }
        if (ParStatus == -7) {
            t_buffer.append("2:server:ready:client");
        }
        if (ParStatus == -8) {
            t_buffer.append("2:server:last_time:client");
        }
        if (ParStatus == -9) {
            t_buffer.append("2:server:stop_all_ack:client");
        }
        if (ParStatus == -10) {
            t_buffer.append("2:server:go_all_ack:client");
        }
        // anti message
        if (ParStatus == -11) {
            t_item = data.loadFromAMQueue(ParId);
            if (t_item != null) {
                t_buffer.append("3:");
                t_buffer.append(t_item.from.toString());
                t_buffer.append(":anti_message:");
                t_buffer.append(t_item.message_1);
                t_buffer.append(":");
                t_buffer.append(t_item.to.toString());
            }
            else {
                return(null);
            }
        }
        // anti message all ack
        if (ParStatus == -12) {
            t_buffer.append("2:server:am_all_ack:client");
        }

        // sim over ack
        if (ParStatus == -13) {
            t_buffer.append("2:server:sim_over_ack:client");
        }
        // last_event deadlock
        if (ParStatus == -14) {
            t_buffer.append("2:server:last_event_deadlock:client");
        }

        t_item = null;
        return(t_buffer.toString());
    }
    
    
}// end class
