/*
 * SimulationData.java
 *
 * Created on 15. duben 2004, 17:24
 */

/**
 *
 * @author  Kuba
 */

import java.io.*;
import java.net.*;
import java.util.*;
import cz.zcu.fav.kiv.jsim.*;

class GeneratorRef {
    public JSimProcess Generator;
    
    public GeneratorRef(JSimProcess ParGeneratorRef) {
        Generator = ParGeneratorRef;
    }
}
    


/**
 *  This Class contain all data to restore simulation after undo or rollback 
 *  operation comin
 *
 */
class TimeItem {
    public double currentTime;
    public double creationTime;
    public double transTq;
    public double linkSumTwRemoved;
    public double linkNoOfItemsRemoved;
    public double linkSumLwUntilLastChange;
    
    public TimeItem(double ParCurrentTime, double ParCreationTime, double ParTransTq,
    double ParLinkSumTw, double ParLinkNoOfItemsRemoved, double ParLinkSumLw){
        
        currentTime = ParCurrentTime;
        creationTime = ParCreationTime;
        transTq = ParTransTq;
        linkSumTwRemoved = ParLinkSumTw;
        linkNoOfItemsRemoved = ParLinkNoOfItemsRemoved;
        linkSumLwUntilLastChange= ParLinkSumLw;
    }
}

/**
 *
 *  This class contain referencis of sinmulation Servers and coresponding queues
 */
class SimServerItem {
    public      String      serverName;
    public      JSimProcess serverRef;
    private     String      queueName;
    public      JSimHead    queueRef;
    public      ArrayList   timeItemState;
    
    public SimServerItem(JSimProcess ParServerRef, JSimHead ParQueueRef) {
        
        timeItemState   = new ArrayList();
        serverRef       = ParServerRef;
        serverName      = new String(serverRef.getName());
        queueRef        = ParQueueRef;
        queueName       = new String(queueRef.getName());
    }
    /**
     *  Store all states to buffer
     *
     */
    public void AddTimeItem(double ParCurrentTime, double ParCreationTime, double ParTransTg,
    double ParLinkSumTw, double ParLinkNoOfItemsRemoved, double ParLinkSumLw) {
        
        timeItemState.add(new TimeItem(ParCurrentTime, ParCreationTime, ParTransTg, ParLinkSumTw, ParLinkNoOfItemsRemoved,  ParLinkSumLw));
        return;
    }
    
    public String GetServerName(){
        return(serverName);
    }
    
    public String GetQueueName(){
        return(serverName);
    }
}




public class SimulationData {
    
    public ArrayList allSimItem;
    
    public SimulationData() {        
        allSimItem = new ArrayList();
    }
    
    /**
     *  Storing referention of all Items in Simulation
     *
     */
    synchronized public int AddSimItem(JSimProcess ParServerRef, JSimHead ParQueueRef){
        
        if (GetIndexSimItem(ParServerRef) != -1) {
            System.out.println("Server' referensis is allready stored in stack");
            return(-1);
        }
        
        allSimItem.add(new SimServerItem(ParServerRef, ParQueueRef));
        return(allSimItem.size());
    }
    
    /**
     *  get index of referensis in list of all component ind simulation
     */
    synchronized public int GetIndexSimItem(JSimProcess ParServerRef) {
        int i, index = -1;
        SimServerItem t_item;
        
        if (allSimItem.size() == 0) return(-1);
        
        if (ParServerRef == null) return(-1);
        
        for(i = 0; i < allSimItem.size(); i++){
            t_item = ((SimServerItem) allSimItem.get(i));
            if (ParServerRef == t_item.serverRef) {
                index = i;
            }
        }
        
        return(index);
    }
    
    /**
     *  Store data to server referens list
     *
     */
    synchronized public int AddTimeItemMain(Server ParServerRef, double ParCurrentTime, double ParCreationTime, double ParTransTg,
    double ParLinkSumTw, double ParLinkNoOfItemsRemoved, double ParLinkSumLw){
        
        int i = 0, index = -1;
        SimServerItem t_item;
        
        index = GetIndexSimItem(ParServerRef);
        
        if (index == -1) {
            System.out.println("Server' referensis isn't stored in stack");
            return(-1);
        }
        
        t_item = ((SimServerItem) allSimItem.get(index));
        
        t_item.AddTimeItem(ParCurrentTime, ParCreationTime, ParTransTg,
        ParLinkSumTw, ParLinkNoOfItemsRemoved, ParLinkSumLw);
        
        return(allSimItem.size());
        
        //return(0);
    }
    
    
    /**
     *
     *  Retur number of all stored item 
     */
    synchronized public int CountOfAllItem(){
        int i, count = 0;
        SimServerItem t_item;
        
        for(i = 0; i < allSimItem.size(); i ++) {
            t_item = ((SimServerItem) allSimItem.get(i));
            count += t_item.timeItemState.size();
        }
        
        return(count);
    }        
}
