/*
 *	Copyright (c) 2000 - 2004, University of West Bohemia,
 *	                           Faculty of Applied Sciences,
 *	                           Department of Computer Science and Engineering,
 *	                           DSS Group.
 *	                           Pilsen, Czech Republic.
 *
 *	Please read the licence agreement carefully before using any part of this software.
 */
package cz.zcu.fav.kiv.jsim;

import java.io.PrintStream;

/**
 *	The JSimMethodNotSupportedException is thrown whenever the user tries to call a method
 *	that is not supported in the current simulation mode.
 *	You should never need to create an instance of this class.
 *
 *	@author		Pavel DOMECK
 *
 *	@version	J-Sim version 0.3.0
 *
 *	@since		J-Sim version 0.2.0
 */
public class JSimMethodNotSupportedException extends JSimException
{
	/**
	 *	Creates a new JSimMethodNotSupportedException with specific information.
	 *
	 *	@param pars	Holds detailed information about specific circumstances of this exception,
	 *			for example a method's or a varibale's name.
	 */
	public JSimMethodNotSupportedException(String pars)
	{
		super("You called a method that is not supported in the current simulation mode.", pars);
	} // constructor

	/*
	 *	Method comments are inherited.
	 */
	public void printComment(PrintStream ps)
	{
		ps.println("It is not allowed to call this method in this simulation mode.");
		ps.println("Calling this method in the current mode would have no meaning.");
		ps.println();

		if (getSpecificInfo() != null)
		{
			ps.println("Additional information: " + getSpecificInfo());
			ps.println();
		}
	} // printComment

} // class JSimMethodNotSupportedException

