/*
 *	Copyright (c) 2000 - 2004, University of West Bohemia,
 *	                           Faculty of Applied Sciences,
 *	                           Department of Computer Science and Engineering,
 *	                           DSS Group.
 *	                           Pilsen, Czech Republic.
 *
 *	Please read the licence agreement carefully before using any part of this software.
 */
package cz.zcu.fav.kiv.jsim;

/**
 *	The JSimProcessDeath class is an internal J-Sim exception used when a process is killed
 *	by the simulation. The JSimProcessDeath exception is propagated from hold() or passivate() via life()
 *	to run() where it is caught.
 *	You should never throw or catch this exception.
 *
 *	@author		<a href="http://home.zcu.cz/~jkacer">Jarda KAER</a>
 *
 *	@version	J-Sim version 0.3.0
 *
 *	@since		J-Sim version 0.1.0
 */
public class JSimProcessDeath extends RuntimeException
{
	/**
	 *	Creates a new JSimProcessDeath exception.
	 */
	public JSimProcessDeath()
	{
		super("J-Sim internal exception. Do not throw it, do not catch it, do not care about it.");
	} // constructor

} // class JSimProcessDeath
