/*
 *	Copyright (c) 2000 - 2004, University of West Bohemia,
 *	                           Faculty of Applied Sciences,
 *	                           Department of Computer Science and Engineering,
 *	                           DSS Group.
 *	                           Pilsen, Czech Republic.
 *
 *	Please read the licence agreement carefully before using any part of this software.
 */
package cz.zcu.fav.kiv.jsim.gui;

import java.util.*;
import javax.swing.*;

/**
 *	An object that implements the JSimDisplayable interface can be displayed in a component of the main
 *	GUI window.
 *
 *	@author		Pavel DOMECK
 *
 *	@version	J-Sim version 0.3.0
 *
 *	@since		J-Sim version 0.2.0
 */
public interface JSimDisplayable
{
	/**
	 *	Returns a string containing basic informations about an object.
	 *	The string will be displayed in a JSimMainWindowList component.
	 *
	 *	@return	A string containing basic informations about an object.
	 */
	public String getObjectListItemDescription();

	/**
	 *	Returns a collection of object's characteristics. Always return a collection of JSimPair objects.
	 *	The collection will be displayed in a JSimDetailedInfoWindow table.
	 *
	 *	@return	A collection of object's characteristics
	 */
	public Collection getDetailedInformationArray();

	/**
	 *	Creates a detailed info window that shows information about an object.
	 *	Returns a reference to the created window.
	 *
	 *	@return	A reference to the created info window.
	 */
	public JDialog createDetailedInfoWindow(JSimMainWindow parentWindow);

} // interface JSimDisplayable

