/*
Example illustrating the use of canvases.
 
This applet has two canvases (of two different kinds)
The basic fuinctionality is implemented here for illustration
purposes. Experiment with this...to learn more!
 */

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.StringTokenizer;



class SimData {
    
    public String   recvName;
    public double   creationTime = 0;
    public double   executionTime = 0;
    public int      undoOrder = 0;
    
    public SimData(double ParExecutionTime, double ParCreationTime, int ParUndoOrder){
        recvName = new String();
        creationTime = ParCreationTime;
        executionTime = ParExecutionTime;
        undoOrder = ParUndoOrder;
    }
    
    public SimData(double ParExecutionTime, double ParCreationTime, int ParUndoOrder, String ParName){
        recvName = new String(ParName);
        creationTime = ParCreationTime;
        executionTime = ParExecutionTime;
        undoOrder = ParUndoOrder;
    }
    
    public void addName(String ParName){
        recvName = ParName;
        return;
    }
}


class CompSimData {
    public ArrayList NetQueue;
    public ArrayList InQueue;
    public ArrayList OutQueue;
    public ArrayList AMQueue;
    public String compName;
    public int[]    undoField;
    
    public CompSimData(String ParCompName){
        undoField = new int[10];
        compName    = new String(ParCompName);
        InQueue     = new  ArrayList();
        OutQueue    = new  ArrayList();
        NetQueue    = new  ArrayList();
        AMQueue     = new  ArrayList();
    }
    
}


public class DrawUnit extends javax.swing.JPanel {
    
    private     VisualData  data;
    private     ArrayList   extrahData;
    private     int         xDim = 0;
    public      int         xScale = 1;
    
    public      boolean     showInputs = true;
    public      boolean     showOutputs = true;
    public      boolean     showDepends= true;
    public      boolean     showAM = true;
    
    DrawUnit(VisualData ParData) {
        data = ParData;
        extrahData = new ArrayList();
        
        FileNameItem    t_item_1; // comp name
        FileNameItem    t_item_2; // file name
        int i, j;
        
        for(j = 0; j < data.getCountOfClient(); j++) {
            try {
                t_item_1 = ((FileNameItem) data.name_queue.get(j));
                i = j*3 + 2;
                t_item_2 = ((FileNameItem) data.filename_queue.get(i));
                this.getNetPoint(t_item_2.fileName, t_item_1.fileName);
                i = j*3 + 1;
                t_item_2 = ((FileNameItem) data.filename_queue.get(i));
                this.getOutPoint(t_item_2.fileName, t_item_1.fileName);
            }
            catch (IndexOutOfBoundsException e) {
                System.out.println("Incorrect internal file structure");
                System.exit(0);
            }
        }
        
    }
    
    public synchronized void paint(Graphics g) {
        super.paint(g);
        
        FileNameItem    t_item_1; // comp name
        FileNameItem    t_item_2; // file name
        CompSimData     t_item_3; // polozka komponenty
        SimData         t_item_4; // polozka casu v komponente
        int i = 0;
        int j = 0;
        int undoCount = 0;
        int undoTime = 0;
        int tempUndoTimeStamp = 0;
        
        this.setPreferredSize(new Dimension(1000*xDim*xScale, 170 * data.getCountOfClient()));
        this.revalidate();
        
        // System.out.println("Delka :" + data.getCountOfClient());
        
        for(j = 0; j < data.getCountOfClient(); j++) {
            
            t_item_1 = ((FileNameItem) data.name_queue.get(j));
            i = j*3 + 2;
            t_item_2 = ((FileNameItem) data.filename_queue.get(i));
            g.drawString(t_item_1.fileName, 10, 20 + (j*120));
            g.drawLine(20, 60 + (j*120), 20 + 1000*xDim*xScale, 60 + (j*120));
            g.drawLine(20, 55 + (j*120), 20, 65 + (j*120));
        }
        int stamp;
        int[] undoField;
        undoField = new int[10];
        
        // projde zavislosti
        for(j = 0; j < this.extrahData.size(); j++) {
            
            undoCount = 0;
            undoTime = 0;
            tempUndoTimeStamp = 0;
            stamp = 0;
            
            t_item_3 = ((CompSimData) this.extrahData.get(j));
            
            // kresli Dependenc
            for(i = 0; i < t_item_3.NetQueue.size(); i++) {
                
                t_item_4 = ((SimData) t_item_3.NetQueue.get(i));
                stamp = (int) t_item_4.executionTime;
                
                if (undoCount < t_item_4.undoOrder) {
                    
                    undoCount = t_item_4.undoOrder;
                    t_item_3.undoField[undoCount] = tempUndoTimeStamp;
                    undoTime = tempUndoTimeStamp;
                    
                }
                tempUndoTimeStamp = stamp;
                if (this.showDepends == true) {
                    this.drawMessageDependens(stamp, j, t_item_4.creationTime, g, undoTime, undoCount);
                }
            }
        }
        
        for(j = 0; j < this.extrahData.size(); j++) {
            
            undoCount = 0;
            undoTime = 0;
            tempUndoTimeStamp = 0;
            stamp = 0;
            
            t_item_3 = ((CompSimData) this.extrahData.get(j));
            
            // kresli NetPointy
            for(i = 0; i < t_item_3.NetQueue.size(); i++) {
                
                t_item_4 = ((SimData) t_item_3.NetQueue.get(i));
                stamp = (int) t_item_4.executionTime;
                
                if (undoCount < t_item_4.undoOrder) {
                    
                    undoCount = t_item_4.undoOrder;
                    t_item_3.undoField[undoCount] = tempUndoTimeStamp;
                    undoTime = tempUndoTimeStamp;
                    
                }
                tempUndoTimeStamp = stamp;
                
                if (this.showAM == true) {
                    this.drawAntiMessage(t_item_4.executionTime, j, 0, g, undoTime, undoCount);
                }
                                
                if (this.showInputs == true) {
                    if ((i % 2) == 0) {
                        g.drawLine((20 + stamp + undoTime)*xScale, 50 + (j*120), (20 + stamp + undoTime)*xScale, 60 + (j*120));
                        this.drawTimeStamp(stamp, j, 0, g, undoTime, undoCount, 1);
                    }
                    else {
                        g.drawLine((20 + stamp + undoTime)*xScale, 60 + (j*120), (20 + stamp + undoTime)*xScale, 70 + (j*120));
                        this.drawTimeStamp(stamp, j, 1, g, undoTime, undoCount, 1);
                    }
                }
            }
            
            undoCount = 0;
            undoTime = 0;
            tempUndoTimeStamp = 0;
            stamp = 0;
            
            // kresli OutPointy
            for(i = 0; i < t_item_3.OutQueue.size(); i++) {
                t_item_4 = ((SimData) t_item_3.OutQueue.get(i));
                stamp = (int) t_item_4.executionTime;
                
                if (undoCount < t_item_4.undoOrder) {
                    undoCount = t_item_4.undoOrder;
                    undoTime = t_item_3.undoField[undoCount];
                    
                    //                    undoTime = undoField[undoCount];
                }
                tempUndoTimeStamp = stamp;
                if (this.showOutputs == true) {
                    if ((i % 2) == 0) {
                        g.drawLine((20 + stamp + undoTime)*xScale, 50 + (j*120), (20 + stamp + undoTime)*xScale, 60 + (j*120));
                        this.drawTimeStamp(stamp, j, 0, g, undoTime, undoCount, 0);
                    }
                    else {
                        g.drawLine((20 + stamp + undoTime)*xScale, 60 + (j*120), (20 + stamp + undoTime)*xScale, 70 + (j*120));
                        this.drawTimeStamp(stamp, j, 1, g, undoTime, undoCount, 0);
                    }
                }
            }
        }
    }
    
    private void drawMessageDependens(int ParTimeStamp, int ParRow, double ParCreationTime, Graphics ParG, int ParUndoStamp, int ParUndoOrder){
        int i, j;
        int x1, x2, y1, y2;
        int rowIndex = 0;
        int undoIndex = 0;
        double Stamp = 0;
        int undoStamp;
        CompSimData t_item_1;
        SimData t_item_2;
        String messageOwner;
        boolean found = false;
        
        t_item_1 = ((CompSimData) this.extrahData.get(ParRow));
        messageOwner = new String(t_item_1.compName);
        
        for(i = 0; i < this.extrahData.size(); i++){
            if (ParRow != i) {
                t_item_1 = ((CompSimData) this.extrahData.get(i));
                for(j = 0; j < t_item_1.OutQueue.size(); j++){
                    t_item_2 = ((SimData) t_item_1.OutQueue.get(j));
                    if (t_item_2.creationTime == ParCreationTime) {
                       /* System.out.println("Depend :" + messageOwner + " : prochazim sim :" + t_item_1.compName + " : tam posila :" + t_item_2.recvName);
                        System.out.println(messageOwner + "XX");
                        System.out.println(t_item_2.recvName + "XX" + messageOwner.equals(t_item_2.recvName));
                        */
                        if (messageOwner.equals(t_item_2.recvName) == true){
                            rowIndex =    i;
                            undoIndex =  t_item_2.undoOrder;
                            Stamp = t_item_2.executionTime;
                            found = true;
                            //System.out.println("OK");
                        }
                    }
                }
            }
        }
        if (found == true) {
            x1 = (20 + ParTimeStamp + ParUndoStamp)*xScale;
            y1 = 60 + (ParRow*120);
            t_item_1 = ((CompSimData) this.extrahData.get(rowIndex));
            undoStamp = t_item_1.undoField[undoIndex];
            x2 = (20 + ParTimeStamp + undoStamp)*xScale;
            y2 = 60 + (rowIndex*120);
            
            ParG.setColor(Color.GRAY);
            ParG.drawLine(x1, y1, x2, y2);
        }
        return;
    }
    
    private void drawAntiMessage(double ParTimeStamp, int ParRow, int ParLow, Graphics ParG, int ParUndoStamp, int ParUndoOrder){
        int i = 0;
        int j = 0;
        int l = 0;
        int m = 0;
        
        CompSimData t_item_1;
        CompSimData t_item_3;
        
        SimData t_item_2;
        int stamp;
        int x_cords[] = {0, 20, 10};
        int y_cords[] = {0, 0, 10};
        
        stamp = (int) ParTimeStamp;
        for(i = 0; i < this.extrahData.size(); i++) {
            
            t_item_1 = ((CompSimData) this.extrahData.get(i));
            
            for(j = 0; j < t_item_1.AMQueue.size(); j++) {
                t_item_2 = ((SimData) t_item_1.AMQueue.get(j));
                if (t_item_2.executionTime == ParTimeStamp) {
                    
                    ParG.setColor(Color.RED);
                    if (i > ParRow) {
                        ParG.fillRect((20 + stamp + ParUndoStamp)*xScale + 1, (j*120) + 40, 9, (ParRow*120) - (j*120));
                        ParG.setColor(Color.BLACK);
                        ParG.drawRect((20 + stamp + ParUndoStamp)*xScale + 1, (ParRow*120) - 40, 9, 20);
                    }
                    else {
                        ParG.fillRect((20 + stamp + ParUndoStamp)*xScale + 1, ((i + 1) *120), 9, (ParRow*120) - ((i + 1)*120) - 20);
                        ParG.setColor(Color.BLACK);
                        ParG.drawRect((20 + stamp + ParUndoStamp)*xScale + 1, ((i + 1) *120), 9, (ParRow*120) - ((i + 1)*120) - 20);
                    }
                    
                    
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + stamp + ParUndoStamp)*xScale - 10, (ParRow*120) - 41, 32 , 12);
                    ParG.setColor(Color.BLACK);
                    ParG.drawRect((20 + stamp + ParUndoStamp)*xScale - 10, (ParRow*120) - 41, 32 , 12);
                    ParG.setColor(Color.RED);
                    ParG.drawString("A  M", (20 + stamp + ParUndoStamp)*xScale - 4, (ParRow*120) - 30);
                    
                    for (int k = 0; k < x_cords.length; k++) {
                        x_cords[k] = x_cords[k] + (20 + stamp + ParUndoStamp)*xScale - 5;
                        y_cords[k] = y_cords[k] + (ParRow*120) - 20;
                    }
                    ParG.setColor(Color.RED);
                    ParG.fillPolygon(x_cords, y_cords, 3);
                    ParG.setColor(Color.BLACK);
                    ParG.drawPolygon(x_cords, y_cords, 3);
                }
            }
        }
        return;
    }
    
    private void drawTimeStamp(int ParTimeStamp, int ParRow, int ParLow, Graphics ParG, int ParUndoStamp, int ParUndoOrder, int ParKind){
        int x1, x2, x3;
        int undoCount = 0;
        Color[] c = {Color.BLACK, Color.RED, Color.BLUE, Color.ORANGE, Color.PINK, Color.MAGENTA, Color.GRAY, Color.GREEN};
        
        undoCount = ParUndoOrder % 5;
        
        x1 = ParTimeStamp % 10;
        x2 = (ParTimeStamp / 10) % 10;
        x3 = (ParTimeStamp / 100) % 10;
        if (ParLow == 0) {
            if ((x3 == 0) & (x2 == 0)){
                
                ParG.setColor(c[7]);
                ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 34 + (ParRow*120), 9, 12);
                ParG.setColor(c[6]);
                ParG.drawRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 34 + (ParRow*120), 9, 12);
                
                ParG.setColor(c[undoCount + 1]);
                ParG.drawString(String.valueOf(x1).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 45 + (ParRow*120));
                
                if (ParKind == 1) {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 24 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("N", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 33 + (ParRow*120));
                }
                else {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 24 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("S", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 33 + (ParRow*120));
                }
                
            }
            else if (x3 == 0) {
                
                ParG.setColor(c[7]);
                ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 24 + (ParRow*120), 9, 22);
                ParG.setColor(c[0]);
                ParG.drawRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 24 + (ParRow*120), 9, 22);
                
                ParG.setColor(c[undoCount + 1]);
                ParG.drawString(String.valueOf(x1).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 45 + (ParRow*120));
                ParG.drawString(String.valueOf(x2).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 35 + (ParRow*120));
                
                if (ParKind == 1) {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 14 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("N", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 23 + (ParRow*120));
                }
                else {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 14 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("S", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 23 + (ParRow*120));
                }
            }
            else {
                
                ParG.setColor(c[7]);
                ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 14 + (ParRow*120), 9, 32);
                ParG.setColor(c[0]);
                ParG.drawRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 14 + (ParRow*120), 9, 32);
                
                ParG.setColor(c[undoCount + 1]);
                ParG.drawString(String.valueOf(x3).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 25 + (ParRow*120));
                ParG.drawString(String.valueOf(x2).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 35 + (ParRow*120));
                ParG.drawString(String.valueOf(x1).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 45 + (ParRow*120));
                
                if (ParKind == 1) {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 4 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("N", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 13 + (ParRow*120));
                }
                else {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 4 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("S", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 13 + (ParRow*120));
                }
            }
        }
        else {
            if ((x3 == 0) && (x2 == 0)){
                
                ParG.setColor(c[7]);
                ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 73 + (ParRow*120), 9, 12);
                ParG.setColor(c[0]);
                ParG.drawRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 73 + (ParRow*120), 9, 12);
                
                ParG.setColor(c[undoCount + 1]);
                ParG.drawString(String.valueOf(x1).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 84 + (ParRow*120));
                
                if (ParKind == 1) {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 86 + (ParRow*120), 11, 10);
                    
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("N", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 95 + (ParRow*120));
                }
                else {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 86 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("S", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 95 + (ParRow*120));
                }
            }
            else if (x3 == 0) {
                
                ParG.setColor(c[7]);
                ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 73 + (ParRow*120), 9, 22);
                ParG.setColor(c[0]);
                ParG.drawRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 73 + (ParRow*120), 9, 22);
                
                ParG.setColor(c[undoCount + 1]);
                ParG.drawString(String.valueOf(x2).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 84 + (ParRow*120));
                ParG.drawString(String.valueOf(x1).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 94 + (ParRow*120));
                
                if (ParKind == 1) {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 96 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("N", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 105 + (ParRow*120));
                }
                else {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 96 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("S", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 105 + (ParRow*120));
                }
            }
            else {
                
                ParG.setColor(c[7]);
                ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 73 + (ParRow*120), 9, 32);
                ParG.setColor(c[0]);
                ParG.drawRect((20 + ParTimeStamp + ParUndoStamp)*xScale, 73 + (ParRow*120), 9, 32);
                
                ParG.setColor(c[undoCount + 1]);
                ParG.drawString(String.valueOf(x3).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 84 + (ParRow*120));
                ParG.drawString(String.valueOf(x2).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 94 + (ParRow*120));
                ParG.drawString(String.valueOf(x1).toString(), (20 + ParTimeStamp + ParUndoStamp)*xScale + 2, 104 + (ParRow*120));
                
                if (ParKind == 1) {
                    
                    //ParG.setColor(this.getBackground());
                    
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 106 + (ParRow*120), 11, 10);
                    
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("N", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 115 + (ParRow*120));
                }
                else {
                    ParG.setColor(Color.YELLOW);
                    ParG.fillRect((20 + ParTimeStamp + ParUndoStamp)*xScale + 3, 106 + (ParRow*120), 11, 10);
                    
                    ParG.setColor(c[0]);
                    ParG.drawString("S", (20 + ParTimeStamp + ParUndoStamp)*xScale + 4, 115 + (ParRow*120));
                }
                
            }
        }
        ParG.setColor(c[0]);
        return;
    }
    
    private int getNetPoint(String ParFileName, String ParName){
        int i = 0;
        int lineCount = 0;
        int itemCount = 0;
        
        CompSimData t_item;
        
        extrahData.add(new CompSimData(ParName));
        i = extrahData.size() - 1;
        // polozka pro danej soubor
        t_item = ((CompSimData) this.extrahData.get(i));
        //System.out.println(i + "." + t_item.compName+ " : " + ParFileName);
        
        try{
            BufferedReader br = new BufferedReader(new FileReader(ParFileName));
            
            String line = br.readLine();
            lineCount++;
            if (this.extrahAndSaveIn(line, t_item) == true) itemCount++;
            while ((line = br.readLine()) != null) {
                //System.out.println(line);
                if (this.extrahAndSaveIn(line, t_item) == true) itemCount++;
                lineCount++;
            }
            System.out.println("Total: " + lineCount+ " Item founds :" + itemCount);
            this.setUndoFlagNet(t_item);
            br.close();
        }
        catch (IOException f){
            System.out.println("Can't open file");
            return(-1);
        }
        return(0);
    }
    
    private void setUndoFlagNet(CompSimData ParItem) {
        int i = 0;
        int undoCount = 0;
        SimData t_item;
        double predTime = Double.MIN_VALUE;
        
        
        for(i = 0; i < ParItem.NetQueue.size(); i++){
            t_item = ((SimData) ParItem.NetQueue.get(i));
            if (t_item.executionTime < predTime) {
                undoCount++;
            }
            t_item.undoOrder = undoCount;
            predTime = t_item.executionTime;
            //System.out.println(t_item.creationTime + " : " + t_item.executionTime + " : " + t_item.undoOrder);
        }
        if (this.xDim < undoCount)
            xDim = undoCount + 1;
        return;
    }
    
    private void setUndoFlagOut(CompSimData ParItem) {
        int i = 0;
        int undoCount = 0;
        SimData t_item;
        double predTime = Double.MIN_VALUE;
        
        
        for(i = 0; i < ParItem.OutQueue.size(); i++){
            t_item = ((SimData) ParItem.OutQueue.get(i));
            if (t_item.executionTime < predTime) {
                undoCount++;
            }
            t_item.undoOrder = undoCount;
            predTime = t_item.executionTime;
            //System.out.println(t_item.creationTime + " : " + t_item.executionTime + " : " + t_item.undoOrder);
        }
        if (this.xDim < undoCount)
            xDim = undoCount + 1;
        return;
    }
    
    private boolean extrahAndSaveIn(String ParLine, CompSimData ParItem){
        int i = 0;
        String[] token;
        token = new String[20];
        double d1, d2;
        
        
        /* com-line broken */
        if (ParLine == null) {
            return(false);
        }
        
        /* getMessageItem */
        StringTokenizer st = new StringTokenizer(ParLine,":");
        
        while(st.hasMoreTokens()) {
            token[i] = new String(st.nextToken());
            i++;
        }
        
        if (i == 3) {
            if (token[0].trim().equals("AntiMessage") == true) {
                System.out.println("Found :" + token[0] + token[1] + token[2]);
                
                try {
                    d1 = Double.valueOf(token[1]).doubleValue();
                    
                }
                catch (NumberFormatException e) {
                    System.out.println("Can't convert variable");
                    return(false);
                }
                ParItem.AMQueue.add(new SimData(d1, d1, 0, token[2]));
            }
        }
        
        
        if ((token[0].equals("Net Point 1") == true) && (i == 5)){
            try {
                d1 = Double.valueOf(token[2]).doubleValue();
                d2 = Double.valueOf(token[4]).doubleValue();
            }
            catch (NumberFormatException e) {
                System.out.println("Can't convert variable");
                return(false);
            }
            ParItem.NetQueue.add(new SimData(d1, d2, 0));
            return(true);
        }
        else
            return(false);
    }
    
    private int getOutPoint(String ParFileName, String ParName){
        int i = 0;
        int lineCount = 0;
        int itemCount = 0;
        
        CompSimData t_item = null;
        
        for(i = 0; i < this.extrahData.size(); i++) {
            t_item = ((CompSimData) this.extrahData.get(i));
            if (t_item.compName.equals(ParName) == true)
                break;
        }
        //System.out.println(i + "." + t_item.compName+ " : " + ParFileName);
        
        try{
            BufferedReader br = new BufferedReader(new FileReader(ParFileName));
            
            String line = br.readLine();
            lineCount++;
            if (this.extrahAndSaveOut(line, t_item) == true) itemCount++;
            while ((line = br.readLine()) != null) {
                if (this.extrahAndSaveOut(line, t_item) == true) itemCount++;
                lineCount++;
            }
            System.out.println("Total: " + lineCount+ " Item founds :" + itemCount);
            this.setUndoFlagOut(t_item);
            br.close();
        }
        catch (IOException f){
            System.out.println("Can't open file");
            return(-1);
        }
        
        // polozka pro danej soubor
        return(1);
    }
    
    private boolean extrahAndSaveOut(String ParLine, CompSimData ParItem){
        int i = 0;
        String[] token;
        token = new String[20];
        double d1, d2;
        
        
        /* com-line broken */
        if (ParLine == null) {
            return(false);
        }
        
        /* getMessageItem */
        StringTokenizer st = new StringTokenizer(ParLine,":");
        
        while(st.hasMoreTokens()) {
            token[i] = new String(st.nextToken());
            i++;
        }
        if (i == 4) {
            try {
                d1 = Double.valueOf(token[1]).doubleValue();
                d2 = Double.valueOf(token[2]).doubleValue();
            }
            catch (NumberFormatException e) {
                System.out.println("Can't convert variable");
                return(false);
            }
            ParItem.OutQueue.add(new SimData(d1, d2, 0, token[0].trim()));
            return(true);
        }
        else
            return(false);
    }
    
    
}
